{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit clcomandosroot ;

{$mode objfpc}{$H+}
interface

uses
Classes, IdComponent,  IdTCPClient;

type
  ThrComandosRoot = class(TThread)
  private
    { Private declarations }
    fhost:string;
    fcodigo:integer;
    fcomando:string;
    fcliente:TIdTcpClient;
  protected
        procedure Execute; override;
  public
       constructor Create(host:string;codigo:integer;comando:string);
  end;


implementation
uses globales;
constructor ThrComandosRoot.Create(host:string;codigo:integer;comando:string);
  begin
      inherited Create(true);
      fhost:=host;
      fcodigo:=codigo;
      fcomando:=comando;
      FreeOnTerminate:=True;
  end;

procedure ThrComandosRoot.Execute;
    begin
        try
            fcliente:=TidTcpClient.create(nil);
            fcliente.Host:=fhost;
            fcliente.port:=PUERTO_ROOT;
            fcliente.connect;
            try
                fcliente.GetResponse(200);
                fcliente.sendCmd(fcomando,fcodigo);
            finally
                fcliente.Disconnect;
                fcliente.free;
            end;
        except
            //writeLn(MEN_ERROR_ENVIAR_COMANDO);
        end;
    end;

end.

