{
  Aulalinex 3.2-0 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit canon;

{$mode objfpc}{$H+}

interface

uses
  clequipoalumno,globales1,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Menus;

type

  { Tfrmcanon }

  Tfrmcanon = class(TForm)
    btnCerrar: TButton;
    imgCerrarCanon: TImage;
    imgApagar: TImage;
    imgIniciarSesion: TImage;
    imgCerrarSesion: TImage;
    imgPizarra1: TImage;
    imgVideoAcabar: TImage;
    imlBoton: TImageList;
    imlBotones1: TImageList;
    imlIcono: TImageList;
    imgArchivoV: TImage;
    imgDVD: TImage;
    imgVCD: TImage;
    imgEncender: TImage;
    imgPizarra: TImage;
    imgVideoIniciar: TImage;
    imgAbrirCanon: TImage;
    imgCaptura: TImage;
    imgFondo: TImage;
    imlmenu: TImageList;
    lblCerrarSesion: TLabel;
    lblCanonNo: TLabel;
    lblEncender: TLabel;
    lblCanon: TLabel;
    lblApagar: TLabel;
    lblIniciarSesion: TLabel;
    lblVideoCerrar1: TLabel;
    lblVideoIniciar: TLabel;
    lblVideoCerrar: TLabel;
    lblPizarra: TLabel;
    lblCaptura: TLabel;
    lblMensaje: TLabel;
    mnuBloquearTR: TMenuItem;
    mnuDesbloquearTR: TMenuItem;
    mnuBloquear: TMenuItem;
    mnuDesbloquear: TMenuItem;
    mnuApagarEquipo: TMenuItem;
    mnuApagaSalva: TMenuItem;
    mnuApagaSalvaEquipo: TMenuItem;
    mnuCerrarProyectorEquipo: TMenuItem;
    mnuCerrarSesion: TMenuItem;
    mnuCerrarSesionEquipo: TMenuItem;
    mnuCerrarVideo1: TMenuItem;
    mnuEncenderEquipo: TMenuItem;
    mnuIniciarProyectorEquipo: TMenuItem;
    mnuIniciarSesion: TMenuItem;
    mnuCerrarProyector: TMenuItem;
    mnuIniciarSesionEquipo: TMenuItem;
    mnuMostrarVideo: TMenuItem;
    mnuArchivoVideo: TMenuItem;
    mnuDVD: TMenuItem;
    mnuMostrarVideoEquipo: TMenuItem;
    mnuVCD: TMenuItem;
    mnuCerrarVideo: TMenuItem;
    mnuPizarra: TMenuItem;
    mnuIniciarProyector: TMenuItem;
    mnuEncenderAula: TMenuItem;
    mnuApagarAula: TMenuItem;
    pnEquipos: TPanel;
    pnFondo: TPanel;
    poMenu: TPopupMenu;
    poMenuEquipo: TPopupMenu;
    ProgressBar1: TProgressBar;
    tmrSesion: TTimer;
    tmrBotones: TTimer;
    tmrSesionFin: TTimer;
    procedure btnCerrarClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure imgAbrirCanonClick(Sender: TObject);
    procedure imgApagarClick(Sender: TObject);
    procedure imgArchivoVClick(Sender: TObject);
    procedure imgArchivoVMouseEnter(Sender: TObject);
    procedure imgArchivoVMouseLeave(Sender: TObject);
    procedure imgCapturaClick(Sender: TObject);
    procedure imgCapturaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgCapturaMouseEnter(Sender: TObject);
    procedure imgCerrarCanonClick(Sender: TObject);
    procedure imgCerrarSesionClick(Sender: TObject);
    procedure imgEncenderClick(Sender: TObject);
    procedure imgEncenderMouseEnter(Sender: TObject);
    procedure imgEncenderMouseLeave(Sender: TObject);
    procedure imgFondoMouseEnter(Sender: TObject);
    procedure imgIniciarSesionClick(Sender: TObject);
    procedure imgPizarra1Click(Sender: TObject);
    procedure imgPizarraClick(Sender: TObject);
    procedure imgVideoAcabarClick(Sender: TObject);
    procedure imgVideoIniciarClick(Sender: TObject);
    procedure imgVideoIniciarMouseEnter(Sender: TObject);
    procedure imgVideoIniciarMouseLeave(Sender: TObject);
    procedure lblVideoCerrarMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuApagarAulaClick(Sender: TObject);
    procedure mnuApagarEquipoClick(Sender: TObject);
    procedure mnuApagaSalvaClick(Sender: TObject);
    procedure mnuApagaSalvaEquipoClick(Sender: TObject);
    procedure mnuArchivoVideoClick(Sender: TObject);
    procedure mnuBloquearClick(Sender: TObject);
    procedure mnuBloquearTRClick(Sender: TObject);
    procedure mnuCerrarProyectorClick(Sender: TObject);
    procedure mnuCerrarProyectorEquipoClick(Sender: TObject);
    procedure mnuCerrarSesionClick(Sender: TObject);
    procedure mnuCerrarSesionEquipoClick(Sender: TObject);
    procedure mnuCerrarVideo1Click(Sender: TObject);
    procedure mnuDesbloquearClick(Sender: TObject);
    procedure mnuDesbloquearTRClick(Sender: TObject);
    procedure mnuDVDClick(Sender: TObject);
    procedure mnuEncenderAulaClick(Sender: TObject);
    procedure mnuEncenderEquipoClick(Sender: TObject);
    procedure mnuIniciarProyectorClick(Sender: TObject);
    procedure mnuIniciarProyectorEquipoClick(Sender: TObject);
    procedure mnuIniciarSesionClick(Sender: TObject);
    procedure mnuIniciarSesionEquipoClick(Sender: TObject);
    procedure mnuMostrarVideoEquipoClick(Sender: TObject);
    procedure tmrBotonesTimer(Sender: TObject);
    procedure tmrSesionFinTimer(Sender: TObject);
    procedure tmrSesionTimer(Sender: TObject);
  private

    procedure ActivarIconos(tiempo: integer);
    procedure AulaApagar;
    procedure AulaCanonAbrir;
    procedure AulaCerrarCanon;
    procedure AulaEncender;
    procedure AulaVideoApagar();
    procedure BloquearTR();
    procedure CrearColocarBotones();
    procedure DesactivarIconos();
    procedure HallarMac;
    procedure imgEquiposClick(Sender: TObject);
    procedure imgEquiposMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    function IniciarPelicula(tipo: integer): boolean;
    procedure Lanzarvideo();
    procedure LetrasColor(n: integer);
    procedure LetrasNegras;
    procedure DesbloquearTR();
    { private declarations }
  public
    { public declarations }
  end; 

var
   frmcanon: Tfrmcanon;
   imgEquipos:Array of TImage;
   lblEquipos:Array of TLabel;
implementation
uses camara1,inicio,globales, elegir;

var
    f_nombrevideo:string;
    f_numequipo:integer=0;
    f_ccanon:integer=0;
    f_cfin:integer=0;
    f_CanonTiempo:integer=4;
    f_contador_refresco:integer=29;
    f_equipo_elegido:integer=0;
{ Tfrmcanon }
Procedure TfrmCanon.CrearColocarBotones();
    var
       alto,posi,icogrupo,i:integer;
    begin
        pnEquipos.Height:=(((g_num_ord_aula -1) div 7)+1)*66;
        for i:=0 to g_num_ord_aula -1 do
            begin
                imgEquipos[i]:= TImage.Create(self);
                with imgEquipos[i] do
                    begin
                        width:=55;
                        Height:=51;
                        posi:=i mod 7;
                        left:=pnEquipos.Width-((posi+1)*(pnEquipos.Width div 7));
                        alto:= i div 7;
                        top:=pnEquipos.Height-((alto+1)*66);
                        Cursor:=crArrow;
                        autosize:=false;
                        Stretch:=true;
                        imlBoton.GetBitmap(0,Picture.Bitmap);
                        Parent:=pnEquipos;
                        PopupMenu:=poMenuEquipo;
                        tag:=i;
                        visible:=true;
                        OnClick:=@imgEquiposClick;
                        OnMouseDown:=@imgEquiposMouseDown;
                        if i< g_num_ord_aula then
                        if equipoalumno[i].EstadoActivadEquipo=eAveriado then
                            begin
                                enabled:=false;
                                imlBoton.GetBitmap(3,Picture.Bitmap);
                           end;
                    end;
                lblEquipos[i]:=TLabel.Create(self);
                with lblEquipos[i] do
                    begin
                        width:=imgEquipos[i].Width;
                        Height:=12;
                        font.Name:='Sans';
                        font.Size:=8;
                        Alignment:=taCenter;
                        Transparent:=true;
                        left:=imgEquipos[i].Left;
                        top:=imgEquipos[i].top+imgEquipos[i].Height;
                        Cursor:=crArrow;
                        Parent:=pnEquipos;
                        visible:=true;
                        Caption:='Mesa ' + inttostr(i+1);
                        AutoSize:=false;
                        if equipoalumno[i].EstadoActivadEquipo=eUsuario then
                            begin
                               Caption:=equipoalumno[i].UsuarioActivo;
                           end;
                    end;
            end;
    end;
procedure Tfrmcanon.imgEquiposClick(Sender: TObject);
    begin
           f_equipo_elegido:=(Sender as TImage).tag;
    end;
procedure Tfrmcanon.imgEquiposMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    begin
          f_equipo_elegido:=(Sender as TImage).tag;
    end;
procedure TfrmCanon.LetrasColor(n:integer);
    begin
        case n of
            0:lblEncender.Font.Color:=rgb(33,89,214);
            1:lblApagar.Font.Color:=rgb(33,89,214);
            2:lblCanon.Font.Color:=rgb(33,89,214);
            3:lblcanonno.Font.Color:=rgb(33,89,214);
            4:lblVideoIniciar.Font.Color:=rgb(33,89,214);
            5:lblVideoCerrar.Font.Color:=rgb(33,89,214);
            6:lblPizarra.Font.Color:=rgb(33,89,214);
            8:lblCaptura.Font.Color:=rgb(33,89,214);
        end;
    end;
procedure TfrmCanon.LetrasNegras;
    var
        i:integer;
    begin
        for i:=0 to controlcount-1 do
            if controls[i] is Tlabel then
                  (controls[i] as tlabel).Font.Color:=rgb(0,0,0);
    end;
procedure TfrmCanon.Lanzarvideo();
    var
        ncontador,i:integer;
    begin
        ncontador:=0;
       for  i:=0 to  high(equipoalumno) do
            begin
                equipoalumno[i].video();
                sleep(100);
                progressbar1.StepIt;
                application.ProcessMessages;
            end ;
    end;

Function TfrmCanon.IniciarPelicula(tipo:integer):boolean;
    const
        ORD_INICIAR_PELI:string='vlc --volume 1024 %s --sout udp:%s --sout-keep --sout-all --audio-desync 1000 --ttl 5 &';
        ORD_INICIAR_PELIDVD:string='vlc --volume 1024 %s --sout udp:%s --sout-keep --sout-all --audio-desync 1000 --ttl 5 &';
        FILTRO_VIDEO:string='Video ( *.mpg,*.mpeg,*.avi)|*.mpg; *.mpeg;*.avi|Todos los Archivos(*.*)|*.*';
    begin
        result:=true;
        if tipo=0 then
            begin
            with Topendialog.create(nil) do
                begin//Seleccionamos el archivo de vídeo
                    Filter:=FILTRO_VIDEO;
                    if  Execute then
                               f_nombrevideo:='"'+filename+'"'
                    else
                        result:=false;
                    free;
                end;
             end;
        if result=false then exit;
        case tipo of
            0:if length(trim(f_nombrevideo))>5 then
                    ordenesaula(ORD_INICIAR_PELI,[f_nombrevideo,g_ipvlc]);
            1:ordenesaula(ORD_INICIAR_PELIDVD,['dvdsimple:///dev/dvd',g_ipvlc]);
            2:ordenesaula(ORD_INICIAR_PELIDVD,['vcd:///dev/cdrom',g_ipvlc])
        end;
        application.ProcessMessages;
        Ejecutar('vlc udp:@' +g_ipvlc+ ' &');
        progressbar1.StepIt;
    end;


Procedure TfrmCanon.HallarMac;
    const
        BUSCAR_MAC:STRING='grep -i %s  /tmp/ndns.txt | cut -f2 -d" "';
        BUSCAR_NOMBRE:STRING='grep -i -c %s /tmp/ndns.txt';
    var
       ordennombre, ordenmac:string;
       i,ordena:integer;
    begin
        for i:=0 to high(equipoalumno) do
            begin
                ordennombre:=format(BUSCAR_NOMBRE,[equipoalumno[i].IP]);
                ordennombre:=trim(HallarDato(ordennombre));
                if ordennombre='' then
                    ordena:=0
                else
                    ordena:=strtoint(ordennombre);
                if ordena > 0 then
                    begin
                        ordenmac:=format(BUSCAR_MAC,[equipoalumno[i].IP]);
                        equipoalumno[i].MAC:=trim(HallarDato(ordenmac));
                     end
                else
                    begin
                        equipoalumno[i].MAC:='00:00:00:00:00:00';
                    end
            end
    end;

Procedure TfrmCanon.DesactivarIconos();
    var
        i:integer;
    begin
        cursor:=crHourGlass;
        application.ProcessMessages;
        for i:= 0  to ControlCount-1 do
           begin
               controls[i].enabled:=false;
               controls[i].cursor:=crHourGlass;
           end;
        progressbar1.Enabled:=true;
    end;

procedure TfrmCanon.AulaVideoApagar();
    var
       i:integer;
    begin
       Ejecutar('killall vlc & 2>>/dev/null');
       for  i:=0 to g_num_ord_aula-1 do
            begin
                  if (equipoalumno[i].EstadoActivadEquipo in [eUsuario]) then
                  begin
                      equipoalumno[i].videoNo();
                      progressbar1.StepIt;
                      application.ProcessMessages;
                  end;
            end ;

     end;

Procedure TfrmCanon.AulaCerrarCanon;
    var
        i:integer;
    begin
       for  i:=0 to g_num_ord_aula-1 do
            begin
                  if (equipoalumno[i].EstadoActivadEquipo in [eUsuario]) then
                     begin
                          equipoalumno[i].mostrarNo();
                          progressbar1.StepIt;
                          application.ProcessMessages;

                  end;
            end ;
        g_IniciadaSesion:=false;
    end;

Procedure TfrmCanon.AulaCanonAbrir;
   var
        i,ncontador:integer;
    begin
        for  i:=0 to g_num_ord_aula-1 do
            begin
                if (equipoalumno[i].EstadoActivadEquipo in [eUsuario]) then
                    begin
              equipoalumno[i].mostrar();
              sleep(100);
              progressbar1.StepIt;
              equipoAlumno[i].ApagaSalva();
              application.ProcessMessages;
                    end;
            end ;

    end;

procedure TfrmCanon.AulaApagar;
    var
        i:integer;
    begin
        for  i:=0 to high(equipoalumno) do
            begin
                equipoalumno[i].encenderNo();
                sleep(100);
                progressbar1.StepIt;
            end;
    end;

Procedure TfrmCanon.ActivarIconos(tiempo:integer);
    var
        i:integer;
        ncontador:integer;
    begin
        ncontador:=0;
        while ncontador <tiempo*10 do
            begin
                sleep(100);
                progressbar1.StepIt;
                application.ProcessMessages;
                inc(ncontador);
            end;
        cursor:=crArrow;
        for i:= 0  to ControlCount-1 do
            begin
                controls[i].enabled:=true;
                controls[i].cursor:=crHandPoint;
            end;
        application.ProcessMessages;
        self.cursor:=crArrow;
        application.ProcessMessages;
        tmrBotones.enabled:=true;
    end;

procedure Tfrmcanon.FormActivate(Sender: TObject);
    begin
        if frmMain.visible then frmMain.Hide;
    end;

procedure Tfrmcanon.btnCerrarClick(Sender: TObject);
    begin
        close;
    end;

procedure Tfrmcanon.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        g_canon_encendido:= false;
        if g_PanelCanon then
            application.Terminate;
    end;

procedure Tfrmcanon.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        if mensaje('¿Deseas salir del cañón?',sino)=2 then
          begin
              canclose:=false;
              exit;
          end;
        if g_IniciadaSesion then AulaCerrarCanon;
        g_Display:='0';
        g_IniciadaSesion:=false;
        application.ProcessMessages;
        frmMain.Show;
        hide;
    end;

procedure Tfrmcanon.FormCreate(Sender: TObject);
    begin
       top:=13;
       IniciarServidorVnc();
       left:=(screen.Width-width) div 2;
       imlIcono.GetBitmap(0,imgArchivoV.Picture.Bitmap);
       imlIcono.GetBitmap(1,imgDVD.Picture.Bitmap);
       imlIcono.GetBitmap(2,imgVCD.Picture.Bitmap);
       g_canon_encendido:=true;
       f_CanonTiempo:=g_CanonTiempo;
       SetLength(imgEquipos,g_num_ord_aula);
       SetLength(lblEquipos,g_num_ord_aula);
       CrearColocarBotones();
    end;

procedure Tfrmcanon.imgAbrirCanonClick(Sender: TObject);
    begin
        if imgAbrirCanon.Enabled = false then exit;
        imgAbrirCanon.Enabled:=false;
        progressbar1.Max:=3*g_num_ord_aula+5;
        progressbar1.Position:=0;
        progressbar1.Visible:=true;
        desactivariconos;
        lblmensaje.caption:='Iniciando proyeción. Espere por favor';
        application.ProcessMessages;
        IniciarServidorVnc();
        application.ProcessMessages;
        AulaCanonAbrir;
        application.ProcessMessages;
        ActivarIconos(1);
        lblmensaje.caption:='';
        progressbar1.Visible:=false;
        imgCerrarCanon.BringToFront;
        imgCerrarCanon.Visible:=true;
        imgAbrirCanon.visible:=false;
        lblcanonno.BringToFront;
        lblcanonno.Visible:=true;
        lblCanon.Visible:=false;
        application.ProcessMessages;
    end;

procedure Tfrmcanon.imgApagarClick(Sender: TObject);
    begin
        if imgApagar.Enabled = false then exit;
        imgApagar.Enabled:=false;
        progressbar1.Max:=50+g_num_ord_aula;
        progressbar1.Position:=0;
        progressbar1.visible:=true;
        application.ProcessMessages;
        lblmensaje.caption:='Apagando los equipos de los alumnos. Espere por favor';
        DesactivarIconos();
        AulaApagar;
        activarIconos(5);
        lblmensaje.caption:='';
        progressbar1.visible:=false;
        imgEncender.visible:=true;
        imgApagar.BringToFront;
        imgApagar.Visible:=false;
        lblencender.BringToFront;
        lblencender.Visible:=true;
        lblapagar.Visible:=false;
        application.ProcessMessages;
    end;

procedure Tfrmcanon.imgArchivoVClick(Sender: TObject);
    var
        tipo:integer;
    begin
        tipo:=(sender as Timage).Tag;
        if imgVideoIniciar.Enabled = false then exit;
        imgVideoIniciar.Enabled:=false;
        imgArchivoV.Visible:=false;
        imgDVD.Visible:=false;
        imgVCD.Visible:=false;
        progressbar1.Max:=g_num_ord_aula+5;
        progressbar1.Position:=0;
        progressbar1.visible:=true;
        application.ProcessMessages;
        lblmensaje.caption:='Iniciando Vídeo. Espere por favor';
        desactivariconos;
        application.ProcessMessages;
        if IniciarPelicula(tipo) then
        begin
            application.ProcessMessages;
            Lanzarvideo;
            imgVideoAcabar.BringToFront;
            imgVideoAcabar.Visible:=true;
            imgVideoIniciar.visible:=false;
            lblVideoCerrar.BringToFront;
            lblVideoCerrar.Visible:=true;
            lblVideoIniciar.Visible:=false;
        end;
        ActivarIconos(0);
        lblmensaje.caption:='';
        progressbar1.Visible:=false;
        progressbar1.Visible:=false;
        application.ProcessMessages;
end;

procedure Tfrmcanon.imgArchivoVMouseEnter(Sender: TObject);
    var
        nimagen:integer;
    begin
        imgEncenderMouseEnter(imgVideoIniciar);
        nimagen:=(sender as Timage).tag;
        nimagen:=nimagen+3;
        (sender as Timage).Picture.Bitmap.clear;
        imlicono.GetBitmap(nimagen,(sender as Timage).Picture.Bitmap);
    end;

procedure Tfrmcanon.imgArchivoVMouseLeave(Sender: TObject);
    var
        nimagen:integer;
    begin
        imgEncenderMouseLeave(imgVideoIniciar);
        nimagen:=(sender as Timage).tag;
        (sender as Timage).Picture.Bitmap.clear;
        imlicono.GetBitmap(nimagen,(sender as Timage).Picture.Bitmap);
    end;

procedure Tfrmcanon.imgCapturaClick(Sender: TObject);
    begin
        self.hide;
        TfrmCamara1.create(self).showmodal;
        self.show;
    end;

procedure Tfrmcanon.imgCapturaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
    begin
        if imgCaptura.enabled =false then exit;
        imgCaptura.Picture.Bitmap.clear;
        imlBotones1.GetBitmap(14,imgCaptura.Picture.Bitmap);
        LetrasNegras;
    end;

procedure Tfrmcanon.imgCapturaMouseEnter(Sender: TObject);
    begin
        if imgCaptura.enabled =false then exit;
        imgCaptura.Picture.Bitmap.clear;
        imlBotones1.GetBitmap(15,imgCaptura.Picture.Bitmap);
        letrascolor(8)
    end;

procedure Tfrmcanon.imgCerrarCanonClick(Sender: TObject);
    begin
        if imgCerrarCanon.Enabled = false then exit;
        imgCerrarCanon.Enabled:=false;
        progressbar1.Max:=g_num_ord_aula;
        progressbar1.Position:=0;
        progressbar1.Visible:=true;
        desactivariconos;
        lblmensaje.caption:='Desconectando los proyectores. Espere por favor';
        application.ProcessMessages;
        AulaCerrarCanon;;
        application.ProcessMessages;
        ActivarIconos(2);
        lblmensaje.caption:='';
        progressbar1.Visible:=false;
        imgAbrirCanon.BringToFront;
        imgAbrirCanon.Visible:=true;
        imgCerrarCanon.visible:=false;
        lblCanon.BringToFront;
        lblCanon.Visible:=true;
        lblcanonno.Visible:=false;
        application.ProcessMessages;
    end;

procedure Tfrmcanon.imgCerrarSesionClick(Sender: TObject);
begin
    if mensaje('Esto cerrará todas las sesiones iniciadas en los equipos encendidos. ¿Desea continuar?', sino)=1 then
      begin
          if imgCerrarSesion.Enabled = false then exit;
            imgCerrarSesion.Enabled:=false;
            progressbar1.Max:=19;
            progressbar1.Position:=0;
            progressbar1.Visible:=true;
            application.ProcessMessages;
            DesactivarIconos();
            lblmensaje.caption:='Cerrando usuarios en equipos alumnos. Espere, por favor';
            lblmensaje.Enabled:=true;
            f_cfin:=0;
            tmrSesionFin.Enabled:=true;
      end;
end;

procedure Tfrmcanon.DesbloquearTR();
    const
        tempcur:string= 'xmodmap -pke > /tmp/.sermodaula';
    var
       i:integer;
    begin
        Ejecutar(tempcur);
        Sleep(1000);
        for i:=0 to g_num_ord_aula-1 do
            begin
                if equipoAlumno[i].EstadoActivadEquipo in [eUsuario] then
                    begin
                        equipoAlumno[i].BloquearNo();
                        Application.ProcessMessages;
                    end;
            end;
        Application.ProcessMessages;
    end;

procedure Tfrmcanon.BloquearTR();
    var
       i:integer;
    begin
        for i:=0 to g_num_ord_aula-1 do
            begin
                if equipoAlumno[i].EstadoActivadEquipo in [eUsuario] then
                    begin
                        equipoAlumno[i].Bloquear();
                        Application.ProcessMessages;
                    end;
            end;
        Application.ProcessMessages;
    end;

procedure Tfrmcanon.tmrSesionFinTimer(Sender: TObject);
    const
        tempcur:string= 'xmodmap -pke > /tmp/.sermodaula';
    var
        i: integer;
        cerrarProcesos:string;
    begin
        if f_cfin=0 then
            begin
                 inc(f_cfin);
                 Ejecutar(tempcur);
                 DesbloquearTR();
            end
        else if f_cfin=12 then
            begin
                equipoProfesor.cierraTodosUsuarios();
                inc(f_cfin);
                for i:=0 to g_num_ord_aula-1 do
                    begin
                        if equipoAlumno[i].EstadoActivadEquipo in [eUsuario, eEncendido] then
                            begin
                                application.ProcessMessages;
                                equipoAlumno[i].canonNo();

                            end;
                    end;

           end
        else if f_cfin>14 then
            begin
                tmrSesionFin.enabled:=false;
                lblmensaje.caption:='';
                progressbar1.Visible:=false;
                imgIniciarSesion.BringToFront;
                imgIniciarSesion.Visible:=true;
                imgCerrarSesion.visible:=false;
                lblIniciarSesion.BringToFront;
                lblCerrarSesion.Visible:=false;
                lblIniciarSesion.Visible:=true;
                application.ProcessMessages;
                ActivarIconos(1);
                IniciarServidorVnc();
            end;
        inc(f_cfin);
        ProgressBar1.Position:=ProgressBar1.Position+1;
    end;
procedure TfrmCanon.AulaEncender;
   var
        i:integer;
   begin
        for  i:=0 to high(equipoalumno) do
            begin
                equipoalumno[i].encender();
                progressbar1.StepIt;
                sleep(200);
                application.ProcessMessages;
            end;
     end;

procedure Tfrmcanon.imgEncenderClick(Sender: TObject);
    const
        MENSA:STRING='Encendiendo equipos. Espere, por favor';
        MENSA1:STRING='Se ha lanzado la orden de inicio a todos los equipos. Si alguno no ha arrancado deberá hacerlo manualmente';
    begin
        if imgEncender.Enabled = false then exit;
        imgEncender.Enabled:=false;
        progressbar1.Max:=400+g_num_ord_aula;
        progressbar1.Position:=0;
        progressbar1.Visible:=true;
        application.ProcessMessages;
        lblmensaje.caption:=MENSA;
        DesactivarIconos();
        AulaEncender;
        activarIconos(60);
        lblmensaje.caption:='';
        progressbar1.Visible:=false;
        imgApagar.BringToFront;
        imgApagar.Visible:=true;
        imgEncender.visible:=false;
        lblapagar.BringToFront;
        lblapagar.Visible:=true;
        lblencender.Visible:=false;
        application.ProcessMessages;
    end;

procedure Tfrmcanon.imgEncenderMouseEnter(Sender: TObject);
    var
        nimagen:integer;
    begin
        nimagen:=(sender as Timage).tag;
        if (sender as Timage).enabled =false then exit;
        nimagen:=nimagen+1;
        (sender as Timage).Picture.Bitmap.clear;
        imlBotones1.GetBitmap(nimagen,(sender as Timage).Picture.Bitmap);
        if (sender as Timage).name='imgVideoIniciar' then
            begin
                imgArchivoV.show;
                imgVCD.show;
                imgDVD.show;
                imgArchivoV.Refresh;
            end;
    end;

procedure Tfrmcanon.imgEncenderMouseLeave(Sender: TObject);
    var
        nimagen:integer;
    begin
        if (sender as Timage).enabled =false then exit;
        nimagen:=(sender as Timage).tag;
        (sender as Timage).Picture.Bitmap.clear;
        imlBotones1.GetBitmap(nimagen,(sender as Timage).Picture.Bitmap);
        LetrasNegras
    end;

procedure Tfrmcanon.imgFondoMouseEnter(Sender: TObject);
    begin
        if ImgArchivoV.visible then
            begin
                ImgArchivoV.Hide;
                imgVCD.Hide;
                imgDVD.Hide;
            end;
    end;

procedure Tfrmcanon.imgIniciarSesionClick(Sender: TObject);
    begin
        if mensaje('Esto iniciará una sesión con un usuario con ratón y teclados bloqueados en todos los equipos encendidos. Este proceso tardará varios minutos ¿Desea continuar?', sino)=1 then
        begin
            if imgIniciarSesion.Enabled = false then exit;
            imgIniciarSesion.Enabled:=false;
            equipoProfesor.cierraTodosUsuarios();
            progressbar1.Max:=f_CanonTiempo*g_num_ord_aula+10;
            progressbar1.Position:=0;
            progressbar1.Visible:=true;
            application.ProcessMessages;
            DesactivarIconos();
            lblmensaje.caption:='Iniciando usuarios en equipos alumnos. Espere, por favor';
            lblmensaje.Enabled:=true;
            f_ccanon:=f_CanonTiempo-1;
            f_numequipo:=0;
            tmrSesion.Enabled:=true;
            IniciarServidorVnc();
        end;
    end;

procedure Tfrmcanon.imgPizarra1Click(Sender: TObject);
    begin
        pnfondo.BringToFront;
        pnfondo.Align:=alclient;
        application.ProcessMessages;
        pnfondo.Visible:=true;
        tfrmelegir.Create(nil).showmodal;
        frmelegir.Free;
        pnFondo.Visible:=false;
    end;

procedure Tfrmcanon.tmrSesionTimer(Sender: TObject);
    var
        usuariocanon:string;
    begin
        if f_ccanon mod f_CanonTiempo =0 then
            begin
                if f_numequipo< g_num_ord_aula then
                    begin
                        if equipoAlumno[f_numequipo].EstadoActivadEquipo in [eEncendido,eUsuario] then
                            begin
                                usuariocanon:= g_host_alumno+ NumOrdLet(f_numequipo);
                                equipoAlumno[f_numequipo].canon(usuariocanon);
                            end;
                    inc(f_numequipo);
                    end;
            end;

        if (f_ccanon > (f_CanonTiempo*g_num_ord_aula+10+f_CanonTiempo)) and (f_numequipo>= g_num_ord_aula) then
            begin
                tmrSesion.enabled:=false;
                lblmensaje.caption:='';
                progressbar1.Visible:=false;
                imgCerrarSesion.BringToFront;
                imgCerrarSesion.Visible:=true;
                imgIniciarSesion.visible:=false;
                lblCerrarSesion.BringToFront;
                lblCerrarSesion.Visible:=true;
                lblIniciarSesion.Visible:=false;
                application.ProcessMessages;
                ActivarIconos(1);
                IniciarServidorVnc();

            end;
        inc(f_ccanon);
        progressbar1.Position:=progressbar1.Position+1;
        Application.ProcessMessages;
    end;

procedure Tfrmcanon.imgPizarraClick(Sender: TObject);
    begin
        pnfondo.BringToFront;
        pnfondo.Align:=alclient;
        application.ProcessMessages;
        pnfondo.Visible:=true;
        tfrmelegir.Create(nil).showmodal;
        frmelegir.Free;
        pnFondo.Visible:=false;
    end;

procedure Tfrmcanon.imgVideoAcabarClick(Sender: TObject);
    begin
        if imgVideoAcabar.Enabled = false then exit;
        imgVideoAcabar.Enabled:=false;
        progressbar1.Max:=50+g_num_ord_aula;
        progressbar1.Position:=0;
        progressbar1.visible:=true;
        application.ProcessMessages;
        lblmensaje.caption:='Cerrando vídeo alumnos. Espere por favor';
        DesactivarIconos();
        application.ProcessMessages;
        AulaVideoApagar;
        activarIconos(5);
        lblmensaje.caption:='';
        progressbar1.visible:=false;
        imgVideoIniciar.BringToFront;
        imgVideoIniciar.visible:=true;
        imgVideoAcabar.Visible:=false;
        lblVideoIniciar.BringToFront;
        lblVideoIniciar.Visible:=true;
        lblVideoCerrar.Visible:=false;
        application.ProcessMessages;
    end;

procedure Tfrmcanon.imgVideoIniciarClick(Sender: TObject);
    begin
        imgArchivoVClick(imgArchivoV);
    end;

procedure Tfrmcanon.imgVideoIniciarMouseEnter(Sender: TObject);
    begin
        imgArchivoV.Visible:=true;
        imgDVD.Visible:=true;
        imgVCD.Visible:=true;
    end;

procedure Tfrmcanon.imgVideoIniciarMouseLeave(Sender: TObject);
    begin
        imgArchivoV.Visible:=false;
        imgDVD.Visible:=false;
        imgVCD.Visible:=false;
    end;

procedure Tfrmcanon.lblVideoCerrarMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

end;

procedure Tfrmcanon.mnuApagarAulaClick(Sender: TObject);
    begin
         imgApagarClick(imgApagar);
    end;

procedure Tfrmcanon.mnuApagarEquipoClick(Sender: TObject);
    begin
         equipoAlumno[f_equipo_elegido].encenderNo();
    end;

procedure Tfrmcanon.mnuApagaSalvaClick(Sender: TObject);
    var
        i:integer;
    begin
        for i:=0 to g_num_ord_aula -1 do
            begin
                equipoAlumno[i].ApagaSalva;
                Application.ProcessMessages;
            end;
    end;

procedure Tfrmcanon.mnuApagaSalvaEquipoClick(Sender: TObject);
    begin
        equipoAlumno[f_equipo_elegido].ApagaSalva();
    end;

procedure Tfrmcanon.mnuArchivoVideoClick(Sender: TObject);
    begin
        imgVideoIniciarclick(imgArchivoV);
    end;

procedure Tfrmcanon.mnuBloquearClick(Sender: TObject);
    begin
          equipoAlumno[f_equipo_elegido].Bloquear();
    end;

procedure Tfrmcanon.mnuBloquearTRClick(Sender: TObject);
    begin
         BloquearTR();
    end;

procedure Tfrmcanon.mnuCerrarProyectorClick(Sender: TObject);
    begin
        imgCerrarCanonClick(imgCerrarCanon);
    end;

procedure Tfrmcanon.mnuCerrarProyectorEquipoClick(Sender: TObject);
    begin
          IniciarServidorVnc();
          equipoAlumno[f_equipo_elegido].mostrarNo();
    end;

procedure Tfrmcanon.mnuCerrarSesionClick(Sender: TObject);
    begin
       imgCerrarSesionClick(imgCerrarSesion);
    end;

procedure Tfrmcanon.mnuCerrarSesionEquipoClick(Sender: TObject);
    const
        tempcur:string= 'xmodmap -pke > /tmp/.sermodaula';
    begin
        Ejecutar(tempcur);
        Application.ProcessMessages;
        equipoAlumno[f_equipo_elegido].BloquearNo();
        sleep(1000);
        equipoAlumno[f_equipo_elegido].cierraUsuario();
        Application.ProcessMessages;
        equipoAlumno[f_equipo_elegido].canonNo();
        f_contador_refresco:=28;
    end;

procedure Tfrmcanon.mnuCerrarVideo1Click(Sender: TObject);
    begin
         equipoalumno[f_equipo_elegido].videoNo();
    end;

procedure Tfrmcanon.mnuDesbloquearClick(Sender: TObject);
    const
        tempcur:string= 'xmodmap -pke > /tmp/.sermodaula';
    begin
         Ejecutar(tempcur);
         Sleep(1000);
         equipoAlumno[f_equipo_elegido].BloquearNo();
    end;

procedure Tfrmcanon.mnuDesbloquearTRClick(Sender: TObject);
    begin
         DesbloquearTR();
    end;

procedure Tfrmcanon.mnuDVDClick(Sender: TObject);
    begin
        imgVideoAcabarClick(imgVideoAcabar);
    end;

procedure Tfrmcanon.mnuEncenderAulaClick(Sender: TObject);
    begin
        imgEncenderClick(imgEncender);
    end;

procedure Tfrmcanon.mnuEncenderEquipoClick(Sender: TObject);
    begin
         equipoAlumno[f_equipo_elegido].encender();
    end;

procedure Tfrmcanon.mnuIniciarProyectorClick(Sender: TObject);
    begin
        imgAbrirCanonClick(imgAbrirCanon)
    end;

procedure Tfrmcanon.mnuIniciarProyectorEquipoClick(Sender: TObject);
    begin
          equipoAlumno[f_equipo_elegido].mostrar();
    end;

procedure Tfrmcanon.mnuIniciarSesionClick(Sender: TObject);
    begin
        imgIniciarSesionClick(imgIniciarSesion);
    end;

procedure Tfrmcanon.mnuIniciarSesionEquipoClick(Sender: TObject);
    var
         usuariocanon:string;
    begin
        if equipoAlumno[f_equipo_elegido].EstadoActivadEquipo in [eEncendido,eUsuario] then
            begin
               f_contador_refresco:=10;
               usuariocanon:= g_host_alumno+ NumOrdLet(f_equipo_elegido);
               equipoAlumno[f_equipo_elegido].canon(usuariocanon);
            end;
    end;

procedure Tfrmcanon.mnuMostrarVideoEquipoClick(Sender: TObject);
    begin
        equipoalumno[f_equipo_elegido].video();
    end;

procedure Tfrmcanon.tmrBotonesTimer(Sender: TObject);
    var
        i:integer;
    begin
         if f_contador_refresco>15 then
             begin
                for i:=0 to g_num_ord_aula-1 do
                    begin
                       lblEquipos[i].Caption:='Mesa ' + inttostr(i+1);
                       if equipoAlumno[i].EstadoActivadEquipo=eApagado then
                          imlBoton.GetBitmap(0,imgEquipos[i].Picture.Bitmap)
                       else if equipoAlumno[i].EstadoActivadEquipo=eUsuario then
                           begin
                              imlBoton.GetBitmap(2,imgEquipos[i].Picture.Bitmap);
                              lblEquipos[i].Caption:=equipoalumno[i].UsuarioActivo;
                           end
                       else if equipoAlumno[i].EstadoActivadEquipo= eAveriado then
                          imlBoton.GetBitmap(3,imgEquipos[i].Picture.Bitmap)
                       else
                          imlBoton.GetBitmap(1,imgEquipos[i].Picture.Bitmap);
                    Application.ProcessMessages;
                    end;
                f_contador_refresco:=0;
             end;
             inc( f_contador_refresco);
    end;

initialization
  {$I canon.lrs}

end.

