{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit cldevolver;

{$mode objfpc}{$H+}

interface
uses
  Classes, SysUtils,IdTCPClient;

type
  ThrDevolverArchivos = class(TThread)
  private
    { Private declarations }
        fcarpeta:string;
        fhost,fcomando:string;
        fcliente:TIdTcpClient;
        fpuerto:integer;
  protected
        procedure Execute; override;
  public
       constructor Create(puerto:integer;host,comando,carpeta:string);
  end;

implementation
uses globales;
constructor ThrDevolverArchivos.Create(puerto:integer;host,comando,carpeta:string);
  begin
      inherited Create(true);
      fpuerto:=puerto;
      fhost:='localhost';
      FreeOnTerminate:=True;
      fcarpeta:=carpeta;
      fcomando:=comando;
  end;

procedure ThrDevolverArchivos.Execute;
    var
        archivo:string;
        orden:string;
        lstream:TFileStream;
    begin
        try
            orden:='cd '+fcarpeta+'; tar -czvf '+inttostr(fpuerto)+'_aulalinex-carpeta.tar.gz *';
            Ejecutar(orden);
            sleep(1000);
            archivo:=fcarpeta+PathDelim+inttostr(fpuerto)+'_aulalinex-carpeta.tar.gz';
            lstream:= TFileStream.Create(archivo,fmOpenRead + fmShareDenyNone);
            fcliente:=TidTcpClient.create(nil);
            fcliente.Host:='localhost';
            fcliente.port:=fpuerto;
            fcliente.connect;
            try
                fcliente.getResponse(200);
                fcliente.sendcmd(fcomando,255);
                fcliente.IOHandler.writebufferopen;
                fcliente.IOHandler.Write(lstream,0,true);
                fcliente.IOHandler.WriteBufferclose;
            finally
                begin
                    fcliente.Disconnect;
                    fcliente.free;
                    lstream.free;
                    if fileexists(archivo) then
                       deletefile(archivo);

                end;
            end;
        except
            //writeLn('Error al enviar el archivo');
        end;
    end;
 end.
