{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit clenviarcarpeta;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,IdTCPClient;

type
  ThrEnviarCarpeta = class(TThread)
  private
    { Private declarations }
        fnequipo:integer;
        fcarpeta:string;
        fhost,fcomando:string;
        fcliente:TIdTcpClient;
        fPuerto:integer;
  protected
        procedure Execute; override;
  public
       constructor Create(nequipo,puerto:integer;host,comando,carpeta:string);
  end;

implementation

uses globales;
constructor ThrEnviarCarpeta.Create(nequipo,puerto:integer;host,comando,carpeta:string);
    begin
        inherited Create(true);
        fnequipo:=nequipo;
        fhost:='localhost';
        FreeOnTerminate:=True;
        fcarpeta:=carpeta;
        fcomando:=comando;
        fPuerto:=puerto;
    end;

procedure ThrEnviarCarpeta.Execute;
    var
        archivo:string;
        padre:string;
        micarpeta,micarpeta1:string;
        orden:string;
        lstream:TFileStream;
    begin
        try

            micarpeta:=ExtractFileName(fcarpeta);
            padre:=ExtractFilePath(fcarpeta);
            orden:='cd "'+padre+'"; tar czvf aulalinex-carpeta'+inttostr(fnequipo)+'.tar.gz "'+micarpeta+'"';
            Ejecutar(orden);
            sleep(1000);
            archivo:=padre+'/aulalinex-carpeta'+inttostr(fnequipo)+'.tar.gz';
            lstream:= TFileStream.Create(archivo,fmOpenRead + fmShareDenyNone);
            fcliente:=TidTcpClient.create(nil);
            fcliente.Host:='localhost';
            fcliente.port:=fPuerto;
            fcliente.connect;
            try
                fcliente.getResponse(200);
                fcliente.sendcmd(fcomando,253);
                fcliente.IOHandler.writebufferopen;
                fcliente.IOHandler.Write(lstream,0,true);
                fcliente.IOHandler.WriteBufferclose;
            finally
                begin
                    fcliente.Disconnect;
                    fcliente.free;
                    lstream.free;
                    if fileexists(archivo) then
                        deletefile(archivo);

                end;
            end;
        except
            writeLn('Error al enviar carpeta');
        end;
    end;

end.
