{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit clpresentador;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,unix,IdTCPClient;

type
  thrPresendador = class(TThread)
  private
    { Private declarations }
        farcontra,fusuario:string;
        fcomando,fhost:string;
        fcliente:TIdTcpClient;
        fpuertovnc,fpuerto:integer;
        procedure observar();
  protected
        procedure Execute; override;
  public
       constructor Create(arcontra:string;puertovnc,puerto:integer;comando,usuario,host:string);
  end;

implementation

constructor thrPresendador.Create(arcontra:string;puertovnc,puerto:integer;comando,usuario,host:string);
  begin
      inherited Create(true);
      fusuario:=usuario;
      fpuertovnc:=puertovnc;
      farcontra:=arcontra;
      fpuerto:=puerto;
      fhost:='localhost';
      fcomando:=comando;
      FreeOnTerminate:=True;
  end;

procedure thrPresendador.observar();
    const
         ORD_VER_SILENCIOSO:string='xvnc4viewer  -ViewOnly -UseLocalCursor=0  -LowColourLevel 1 -Shared -passwd %s -geometry 1020x715+0+0  localhost:%d -name %s & 2>>/dev/null';
    var
        orden:string;
    begin
        orden:=Format(ORD_VER_SILENCIOSO,[farcontra,fpuertovnc,fusuario]);
        fpsystem(orden);
    end;

procedure thrPresendador.Execute;
    begin
        try
            fcliente:=TidTcpClient.create(nil);
            fcliente.Host:=fhost;
            fcliente.port:=fpuerto;
            fcliente.connect;
            try
                   fcliente.GetResponse(200);
                   fcliente.sendCmd(fcomando,217);
                   sleep(1000);
                   observar();
            finally
                fcliente.Disconnect;
                fcliente.free;
            end;

        except
              // writeLn('Error al enviar el comando');
        end;
    end;
end.

