{
  Aulalinex 3.2-0 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit inicio;

{$mode objfpc}{$H+}

interface
uses
  LCLType,IniFiles,textomensajes,globales,globales1,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls, Menus,
  StdCtrls, Buttons, EditBtn, ComCtrls, RTTICtrls,  IdURI,  IdCmdTCPServer, IdCommandHandlers, ColorProgress;

type


  { TfrmMain }

  TfrmMain = class(TForm)
    btnEleMen1: TButton;
    btnVer: TButton;
    btnEliRec: TButton;
    btnEleMen: TButton;
    btnEliPag: TButton;
    btnAndar: TButton;
    btnCarVlc: TButton;
    btnAnaPag: TButton;
    btnCargarWeb: TButton;
    btnIniciar: TButton;
    btnDetener: TButton;
    btnParar: TButton;
    btnFavoritos: TButton;
    btnGuardarF: TButton;
    chkVer: TCheckBox;
    chkMostrar: TCheckBox;
    cboAsiDev: TComboBox;
    cboCurDev: TComboBox;
    cboAsiRec: TComboBox;
    cboRec: TComboBox;
    chkPresentacion: TCheckBox;
    chkDesactivar: TCheckBox;
    chkTec: TCheckBox;
    chkVlc: TCheckBox;
    deCarpetas: TDirectoryEdit;
    edAsuVer: TEdit;
    edAsuMen: TEdit;
    edCarpetas: TEdit;
    edMostrar: TEdit;
    edNomVlc: TEdit;
    edPagina: TEdit;
    edAsuDev: TEdit;
    edAsuRec: TEdit;
    edAsuTec: TEdit;
    edPresentacion: TEdit;
    edDesactivar: TEdit;
    fnArchivo: TFileNameEdit;
    IdCmdTCPServer1: TIdCmdTCPServer;
    Image1: TImage;
    imgFotoAlumno: TImage;
    imgCanon: TImage;
    imlFoto: TImageList;
    imlIcoAct1: TImageList;
    imgExamen: TImage;
    imgIco: TImage;
    imgFondoPrincipal: TImage;
    imgPanelCanon: TImage;
    imldisabled: TImageList;
    imlEncender: TImageList;
    imlLogos: TImageList;
    imlvara: TImageList;
    imlCanon: TImageList;
    imlIcoIna: TImageList;
    imlmenu: TImageList;
    imlIcoDis: TImageList;
    imgPresentacion: TImage;
    Label1: TLabel;
    Label14: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label22: TLabel;
    Label26: TLabel;
    Label28: TLabel;
    Label3: TLabel;
    Label32: TLabel;
    Label4: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label5: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    Label6: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label7: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    Label77: TLabel;
    Label78: TLabel;
    Label79: TLabel;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    Label83: TLabel;
    Aviso: TLabel;
    Label84: TLabel;
    lblOficina: TLabel;
    lblOtros: TLabel;
    lblGraficos: TLabel;
    Label2: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lblExamen: TLabel;
    lblGrupo: TLabel;
    lblInfo: TLabel;
    lstPag: TListBox;
    MenuItem3: TMenuItem;
    mnuFotosNoVer: TMenuItem;
    mnuFotosVer: TMenuItem;
    mnuRestaurarAula: TMenuItem;
    mnug34: TMenuItem;
    mnuUsuarios: TMenuItem;
    mnug45: TMenuItem;
    mnuEjemplo: TMenuItem;
    mnuAnadir: TMenuItem;
    mnuGrupos: TMenuItem;
    meVer: TMemo;
    menuAula: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    EliminarArchivosAlumno: TMenuItem;
    mnuExamen: TMenuItem;
    Calculadora1: TMenuItem;
    meMostrar: TMemo;
    meTexArc: TMemo;
    meArcDev: TMemo;
    meTexRec: TMemo;
    meTec: TMemo;
    mePresentacion: TMemo;
    meDesactivar: TMemo;
    meCarpertas: TMemo;
    meVlc: TMemo;
    mnuApagarServidor: TMenuItem;
    Administrador1: TMenuItem;
    meTexMen: TMemo;
    mnuManual: TMenuItem;
    mnuAcercade: TMenuItem;
    mnug16: TMenuItem;
    mnuConfProfe: TMenuItem;
    mnuDesconectarClientes: TMenuItem;
    mnuIniciarClientes: TMenuItem;
    mnug14: TMenuItem;
    mnuIniciarServidor: TMenuItem;
    mnuVNC: TMenuItem;
    mnuNot: TMenuItem;
    mnug10: TMenuItem;
    OpenDialog1: TOpenDialog;
    OpenDialog3: TOpenDialog;
    pnFotos: TPanel;
    pnTipo: TPanel;
    pnMos: TPanel;
    pnlan: TPanel;
    pnPrioridad: TPanel;
    pnEnc: TPanel;
    pnTec: TPanel;
    pnMen: TPanel;
    pnRec: TPanel;
    pnDev: TPanel;
    pnArc: TPanel;
    pnAlu: TPanel;
    pnCar: TPanel;
    pnNav: TPanel;
    pnTipoVlc: TPanel;
    pnVer: TPanel;
    pnVlc: TPanel;
    pnFondo: TPanel;
    pnDes: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    spExa: TSpeedButton;
    spCue: TSpeedButton;
    spEnc: TSpeedButton;
    spApl: TSpeedButton;
    spNav: TSpeedButton;
    spVid: TSpeedButton;
    spPro: TSpeedButton;
    spAlu: TSpeedButton;
    spCam: TSpeedButton;
    spBlo: TSpeedButton;
    spVer: TSpeedButton;
    spMos: TSpeedButton;
    spInt: TSpeedButton;
    spMen: TSpeedButton;
    spArc: TSpeedButton;
    spCar: TSpeedButton;
    spRec: TSpeedButton;
    spDev: TSpeedButton;
    tmrExamen: TTimer;
    Timer2: TTimer;
    Video1: TMenuItem;
    mnuCD: TMenuItem;
    mnuIniEva: TMenuItem;
    mnuCanonEncender: TMenuItem;
    mnuCamara: TMenuItem;
    mnug8: TMenuItem;
    mnuPresentaAlu: TMenuItem;
    mnuVerPre: TMenuItem;
    mnuMostrarVlc: TMenuItem;
    mnuNavegar: TMenuItem;
    mnuLanzarAplica: TMenuItem;
    mnuEnvRec: TMenuItem;
    mnuArcRec: TMenuItem;
    mnuArcEnv: TMenuItem;
    mnug5: TMenuItem;
    mnuRecibirArchivo: TMenuItem;
    mnuDevTod: TMenuItem;
    mnug7: TMenuItem;
    mnuEnvCar: TMenuItem;
    mnuEnviarArchivo: TMenuItem;
    mnuMensaje: TMenuItem;
    mnuProgramas: TMenuItem;
    mnug4: TMenuItem;
    mnuApagaSalva: TMenuItem;
    mnuDesactivar: TMenuItem;
    mnuDesactivarTR: TMenuItem;
    mnug3: TMenuItem;
    mnuMostrar: TMenuItem;
    mnuVer: TMenuItem;
    mnuAyuda: TMenuItem;
    mnuConfigurar: TMenuItem;
    mnuUtilidades: TMenuItem;
    mnuEvaluar: TMenuItem;
    mnuCanon: TMenuItem;
    mnuPresenta: TMenuItem;
    mnuVideo: TMenuItem;
    mnuLanzador: TMenuItem;
    mnuMensajes: TMenuItem;
    mnuObservar: TMenuItem;
    mnuApagar: TMenuItem;
    mnuRefrescar: TMenuItem;
    mnuSalir: TMenuItem;
    mnuNombreAlu: TMenuItem;
    mnuEncender: TMenuItem;
    mnuAula: TMenuItem;
    pnPresenta: TPanel;
    procedure actualizarUsuarioCommand(ASender: TIdCommand);
    procedure Administrador1Click(Sender: TObject);
    procedure btnAnaPagClick(Sender: TObject);
    procedure btnAndarClick(Sender: TObject);
    procedure btnCargarWebClick(Sender: TObject);
    procedure btnCarImaClick(Sender: TObject);
    procedure btnCarVlcClick(Sender: TObject);
    procedure btnDetenerClick(Sender: TObject);
    procedure btnEleMen1Click(Sender: TObject);
    procedure btnEleMenClick(Sender: TObject);
    procedure btnEliPagClick(Sender: TObject);
    procedure btnEliRecClick(Sender: TObject);
    procedure btnFavoritosClick(Sender: TObject);
    procedure btnGuardarFClick(Sender: TObject);
    procedure btnIniciarClick(Sender: TObject);
    procedure btnPararClick(Sender: TObject);
    procedure btnVerClick(Sender: TObject);
    procedure Calculadora1Click(Sender: TObject);
    procedure cboAsiDevChange(Sender: TObject);
    procedure cboAsiDevKeyPress(Sender: TObject; var Key: char);
    procedure cboAsiRecKeyPress(Sender: TObject; var Key: char);
    procedure cboCurDevKeyPress(Sender: TObject; var Key: char);
    procedure deCarpetasChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure imgCanonClick(Sender: TObject);
    procedure imgCanonMouseEnter(Sender: TObject);
    procedure imgCanonMouseLeave(Sender: TObject);
    procedure imgFondoPrincipalMouseEnter(Sender: TObject);
    procedure mnuFotosNoVerClick(Sender: TObject);
    procedure mnuFotosVerClick(Sender: TObject);
    procedure munCerrarCanonClick(Sender: TObject);
    procedure mnuDevExaClick(Sender: TObject);
    procedure mnuEjemploClick(Sender: TObject);
    procedure mnuExamenClick(Sender: TObject);
    procedure fnArchivoChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure imgPanelCanonClick(Sender: TObject);
    procedure imgPanelCanonMouseEnter(Sender: TObject);
    procedure imgPanelCanonMouseLeave(Sender: TObject);
    procedure lblExamenClick(Sender: TObject);
    procedure lstPagClick(Sender: TObject);
    procedure lstPagDblClick(Sender: TObject);
    procedure mnuAcercadeClick(Sender: TObject);
    procedure mnuAnadirClick(Sender: TObject);
    procedure mnuApagarServidorClick(Sender: TObject);
    procedure mnuApagarClick(Sender: TObject);
    procedure mnuApagaSalvaClick(Sender: TObject);
    procedure mnuArcEnvClick(Sender: TObject);
    procedure mnuArcRecClick(Sender: TObject);
    procedure mnuCamaraClick(Sender: TObject);
    procedure mnuCDClick(Sender: TObject);
    procedure mnuConfProfeClick(Sender: TObject);
    procedure mnuDesactivarClick(Sender: TObject);
    procedure mnuDesactivarTRClick(Sender: TObject);
    procedure mnuDesconectarClientesClick(Sender: TObject);
    procedure mnuDevTodClick(Sender: TObject);
    procedure mnuEncenderClick(Sender: TObject);
    procedure mnuEnvCarClick(Sender: TObject);
    procedure mnuEnviarArchivoClick(Sender: TObject);
    procedure mnuEnvRecClick(Sender: TObject);
    procedure mnuIniciarClientesClick(Sender: TObject);
    procedure mnuIniciarServidorClick(Sender: TObject);
    procedure mnuIniEvaClick(Sender: TObject);
    procedure mnuCanonEncenderClick(Sender: TObject);
    procedure mnuLanzarAplicaClick(Sender: TObject);
    procedure mnuManualClick(Sender: TObject);
    procedure mnuMensajeClick(Sender: TObject);
    procedure mnuMostrarClick(Sender: TObject);
    procedure mnuMostrarVlcClick(Sender: TObject);
    procedure mnuNavegarClick(Sender: TObject);
    procedure mnuNotClick(Sender: TObject);
    procedure mnuPresentaAluClick(Sender: TObject);
    procedure mnuProgramasClick(Sender: TObject);
    procedure mnuRecibirArchivoClick(Sender: TObject);
    procedure mnuRefrescarClick(Sender: TObject);
    procedure mnuRestaurarAulaClick(Sender: TObject);
    procedure mnuSalirClick(Sender: TObject);
    procedure mnuUsuariosClick(Sender: TObject);
    procedure mnuVerClick(Sender: TObject);
    procedure mnuVerPreClick(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure spBloClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure tmrExamenTimer(Sender: TObject);
    procedure Video1Click(Sender: TObject);
  private
    Ordenata:Array of TImage;
    imgFotos:Array of Timage;
    imgFoto:Array of Timage;
    lblOrdenata:Array of Tlabel;
    lblMesa:array of Tlabel;
    spDarRaton:Array of TspeedButton;
    menusaulas:array of TmenuItem;
    tmrBarra:array of TTimer;
    pgOrdenata:array of TColorProgress;
    rbApl:Array of TradioButton;
    spGrupos:array of Tspeedbutton;
    procedure ActualizarMonitores;
    procedure AlumnoAplicacion(ord_num, tipo_aplicacion: integer);
    procedure AlumnoArchivo(ord_num: integer);
    procedure AlumnoArchivoNo(ord_num:integer);
    procedure AlumnoAplicacionNo(ord_num:integer);
    procedure AlumnoCarpeta(ord_num: integer);
    procedure AlumnoCarpetaNo(ord_num:integer);
    procedure AlumnoDevolver(ord_num: integer);
    procedure AlumnoDevolverNo(ord_num: integer);
    procedure AlumnoEncender(ord_num: integer);
    procedure AlumnoEncenderNo(ord_num: integer);
    procedure AlumnoInternetNo(ord_num: integer);
    procedure AlumnoInternetSi(ord_num: integer);
    procedure AlumnoLimpiarEnviar();
    procedure AlumnoLimpiarRecibidos();
    procedure AlumnoLimpiarRecibidosEnviados();
    procedure AlumnoMensaje(ord_num: integer);
    procedure AlumnoMensajeNo(ord_num: integer);
    procedure AlumnoMostrar(ord_num: integer);
    procedure AlumnoMostrarNo(ord_num: integer);
    procedure AlumnoNavegar(ord_num: integer);
    procedure AlumnoNavegarNo(ord_num: integer);
    procedure AlumnoPresentacion(ord_num: integer);
    procedure AlumnoPresentacionNo(ord_num: integer);
    procedure AlumnoRatonNo(ord_num: integer);
    procedure AlumnoRatonSi(ord_num: integer);
    procedure AlumnoRecibir(ord_num: integer);
    procedure AlumnoRecibirNo(ord_num:integer);
    procedure AlumnoTecladoRatonNo(ord_num: integer);
    procedure AlumnoTecladoRatonSi(ord_num:integer);
    procedure AlumnoVer(ord_num: integer; presenta: boolean=false);
    procedure AlumnoVerNo(ord_num:integer);
    procedure AlumnoVlc(ord_num: integer);
    procedure AlumnoVlcNo(ord_num: integer);
    procedure ApagarSalvaPantallas();
    procedure CambiarEstadoBotonRaton(i: integer; est: Boolean);
    procedure CambiarIconoActivo(ord_num: integer);
    procedure CambiarIconoInactivo(ord_num: integer);
    procedure cargarImagenGeneral(numequipo:integer);
    procedure CargaImagenFoto(sArc:String);
    procedure CargaImagenFotos(i: integer; sArc: String);
    procedure CargarConfiguracionAula(archivoaula: string);
    procedure CargarConfiguracionUsuario();
    procedure CargarDatosAula();
    procedure CargarNombresAlumnos();
    procedure CargarSubgruposAlumnos(aula: integer);
    procedure ColocarPaneles();
    procedure ComenzarUnGrupo(grupo, aula: integer);
    procedure ComprobarEstadoOrdenadores(numero_pantalla: integer);
    procedure CrearColocarComponentes();
    procedure DesmarcarMenus();
    procedure despulsarMonitores(numero_pant: integer);
    procedure DetenerActividad(numero_pantalla: integer; ord_num: integer);
    procedure DevolverExamen(examen: string);
    procedure EjecutarOrdenesFin(tipo:integer;estado:boolean;EnviarMensaje:boolean=false;asunto:string='Aviso';texto:string='Mensaje del profesor');
    procedure EliminarRecibidos();
    procedure EscaparRaton();
    function HallaHost (numord : integer ): string ;
    procedure HallarEquiposDnsMasq(malumno: string; numor: integer;
      var numequipos: integer);
    procedure HallarMac;
    procedure imgFotoOnMouseEnter(Sender: TObject);
    procedure imgFotoOnMouseLeave(Sender: TObject);
    procedure ImgPresentaClic();
    procedure IniciarActividad(numero_pantalla: integer; ord_num: integer);
    procedure IniciarCanon();
    procedure IniciarPelicula();
    procedure IniciarPrograma();
    procedure IniciarRelojes();
    procedure IniciarTCPCMD();
    procedure IniciarVariables;
    procedure iniciarvnc(tipo: integer);
    procedure MensajeEnviado(ord_num:integer; asunto,texto:string);
    procedure menuaulasclick(sender: Tobject);
    procedure MenusClick(MenuPulsado: Tmenuitem; PantallaNumero: integer;
      GbParametros: TPanel; BotonHerramientas: Tspeedbutton);
    procedure ModificarProgramas();
    procedure MostrarMenus;
    procedure MostrarOrdenadores();
    procedure MostrarPanel(gb: TPanel);
    procedure MostrarPersonal();
    function NombreUsuarioOrdenador(numord: integer): string;
    function NumeroOrdenadorePantalla(numero_ordenadores: integer): integer;
    procedure ObtenerInicioFin(ord_num:integer;var inicio:integer; var fin:integer);
    procedure OcultarMenus;
    procedure OrdenataClick(sender: TObject);
    procedure OrdenEjecutarTodos(numero_pantalla: integer);
    procedure OrdenRestablecerTodos(numero_pantalla: integer);
    procedure pintarlogos(numero_pantalla: integer);
    procedure PintarMonPant0(numEquipo:integer);
    procedure PintarMonPantOtros(numEquipo: integer);
    function PrioridadMensaje: string;
    procedure pulsarMonitores(numero_pant: integer);
    procedure rbAplClick(sender: Tobject);
    procedure RecargarAplicaciones();
    procedure RefrescarRecogidos(var combo: TcomboBox; directorio: string);
    procedure RevisarGruposActivos(numequipo: integer);
    procedure spdarratonclick(sender: Tobject);
    procedure spgruposclick(sender: Tobject);
    procedure TerminarCanon();
    function tipoObservacion(): integer;
    procedure tmrBarraTimer(Sender: TObject);
    function TodosApagados(const RevisarAlu: boolean=false;
      const mostrar_mensaje: boolean=true): boolean;
    function ValidarContenido(PantallaActual: integer): boolean;
    procedure VerPresentador(ord_num: integer);
    { private declarations }
  public
    { public declarations }
    procedure CargarGruposAlumnos();
    procedure ExamenActivo();
    procedure ExamenFinalizado();
    Procedure RefrescarEquipoAulaNuevo(numero:integer;actividad:TEstadoActividadEquipo;usuario:string='');
   end;

var
  frmMain: TfrmMain;

implementation

{ TfrmMain }
uses canon,clequipoalumno,agenda,configurarprofesor,evaluar,camara1,procesos,configurarpro,examen,nombresalumnos,acerca,elegir,clequipoprofe;
const
    FILTRO_TXT:string='Archivos de texto (*.txt)|*.txt|Todos los archivos (*.*)|*.*';
    ORD_APAGA_XVNC:string='killall  xvnc4viewer & 2>>/dev/null';
    ORD_EJECUTAR_EN_PROFE:string='%s & 2>> /dev/null';
    ORD_APAGAR_EN_PROFE:string='killall  %s 2>>/dev/null' ;
    P_XVNC:string='xvnc4viewer';
    W_ORDENADOR:integer=66;H_ORDENADOR:integer=61;
    L_GROUPBOX:integer=7;T_GROUPBOX:integer=147;W_GROUPBOX:integer=425;H_GROUPBOX:integer=439;
var
    f_NumeroPantallas:integer=14;
    f_PantallaActiva:integer=0;
    f_AmoRaton:integer=-1;
    f_AlumnoPresentado:boolean=false;
    f_OrdenadorPresentado:integer=-1;
    f_NumeroAplicacion:integer=0;
    f_MostrarUsuarios:boolean=true;
    f_miaula:integer;
    f_NombreMigrupo:string;
    f_grupo:boolean=false;
    f_contadorinicio:integer=0;
    f_camara:boolean=false;
    fcontadorbarra:array [0..23] of integer;
function TfrmMain.NombreUsuarioOrdenador(numord:integer):string;
    var
        nombre:string;
    begin
          nombre:='';
          if (equipoAlumno[numord].EstadoActivadEquipo = eUsuario ) then
              begin
                  if g_GrupoPertenece then
                      begin
                          if trim(equipoAlumno[numord].NombreMiembroGrupo)<>'' then
                              nombre:=equipoAlumno[numord].NombreMiembroGrupo
                          else
                              nombre:='Mesa ' + NumOrdLet(numord);
                      end
                  else
                      begin
                           if (trim(equipoAlumno[numord].UsuarioActivo)<>'') then
                              nombre:=equipoAlumno[numord].UsuarioActivo
                           else
                              nombre:='Mesa ' + NumOrdLet(numord);
                      end
              end
          else
              begin
                   nombre:='Mesa ' + NumOrdLet(numord);
              end;

              result:=nombre;
    end;
Procedure TfrmMain.RefrescarEquipoAulaNuevo(numero:integer;actividad:TEstadoActividadEquipo;usuario:string='');
    var
        estadoActividad:TEstadoActividadEquipo;
        i: integer;
        usuariofoto:string;
    begin
        equipoalumno[numero].EstadoActivadEquipo:=actividad;
        equipoalumno[numero].UsuarioActivo:=usuario;
        estadoActividad:= equipoalumno[numero].EstadoActivadEquipo;
        usuariofoto:=equipoalumno[numero].UsuarioActivo;
        lblOrdenata[numero].caption:= NombreUsuarioOrdenador(numero);
        if (estadoActividad in [eEncendido,eUsuario,eApagado,eEncendiendo]) then equipoAlumno[numero].PararRelojApagando();
        if (estadoActividad in [eEncendido,eUsuario,eApagado,eApagando]) then equipoAlumno[numero].PararRelojEncendiendo();
        if (g_fotos_existen and g_mostrar_todas_fotos ) and (f_PantallaActiva=0) and (estadoActividad= eUsuario)  then
           begin
               cargarImagenGeneral(numero);
               imgFotos[numero].BringToFront;
               imgFotos[numero].visible:=true;
           end
        else
           begin
                imgFotos[numero].visible:=false;
           end;
        if g_fotos_existen then
        begin
          if not g_mostrar_todas_fotos then
              imgFoto[numero].visible:= (EstadoActividad=eUsuario)
          else
              imgFoto[numero].visible:= (EstadoActividad=eUsuario) and (f_PantallaActiva<>0);
        end;
        Case EstadoActividad of
        eAveriado,eApagado,eApagando:
            begin
                 for i:= 0 to f_NumeroPantallas -1 do
                     begin
                          equipoAlumno[numero].fIconoMonitor[i]:=0;
                          equipoAlumno[numero].fMonitorPulsado[i]:=false;
                     end;
            end;
         eEncendido,eUsuario:
             begin
                 equipoAlumno[numero].fmonitorPulsado[0]:=true;
                 equipoAlumno[numero].fIconoMonitor[0]:=1;
             end;
         eEncendiendo:
             for i:= 1 to f_NumeroPantallas -1 do
                 begin
                      equipoAlumno[numero].fIconoMonitor[i]:=0;
                      equipoAlumno[numero].fMonitorPulsado[i]:=false;
                 end;
        end;
        Case f_PantallaActiva of
            0:PintarMonPant0(numero);
        else
            PintarMonPantOtros(numero);
        end;
        ordenata[numero].refresh;
        RevisarGruposActivos(numero);
    end;

procedure TfrmMain.DevolverExamen(examen:string);
    var
        i:integer;
    begin
        for  i:=0 to high(equipoalumno) do
            equipoalumno[i].RefrescarEncendido();
        Application.ProcessMessages;
        for  i:=0 to high(equipoalumno) do
            begin
                if equipoAlumno[i].UsuarioActivo='' then break;
                equipoProfesor.ArcExamenCorregido:=  equipoProfesor.DirExaCorregidos+PathDelim+examen+PathDelim+equipoalumno[i].UsuarioActivo+'.txt';
                equipoalumno[i].devolverExamenCorregido();
            end;
    end;

procedure TfrmMain.IniciarTCPCMD();
    begin
        with IdCmdTCPServer1 do
            begin
                Bindings.Clear;
                Bindings.Add;
                Bindings.items[0].IP:='0.0.0.0';
                Bindings.Items[0].Port:=37256;
                DefaultPort:=37256;
                active:=false;
            end;
    end;

procedure TfrmMain.actualizarUsuarioCommand(ASender: TIdCommand);
    begin
           //
    end;

procedure TfrmMain.RevisarGruposActivos(numequipo:integer);
    begin
        if not lblOrdenata[numequipo].Visible then
            begin
                with ordenata[numequipo] do
                    begin
                        Picture.Bitmap.clear;
                        imldisabled.GetBitmap(0,Picture.Bitmap);
                        Enabled:=false;
                        cursor:=crarrow;
                    end;
            end;
    end;

procedure TfrmMain.ComenzarUnGrupo(grupo,aula:integer);
    var
       i:integer;
    begin
        for i:=0 to g_num_ord_aula -1 do
            begin
                lblOrdenata[i].Visible:=true;
                Ordenata[i].Enabled:=true;
                spDarRaton[i].Enabled:=equipoalumno[i].iconoEquipo(2)=1;
            end;
        comprobarEstadoOrdenadores(f_PantallaActiva);
        if  grupo=-1 then
            begin
                lblgrupo.Caption:=f_NombreMigrupo;
                f_grupo:=false;
                btnandar.Caption:=CAPTION_BOTONES_ACTIVOS[f_PantallaActiva];
                btnparar.Caption:=CAPTION_BOTONES_INACTIVOS[f_PantallaActiva];
                exit;
            end;
            for i:=0 to g_num_ord_aula -1 do
                Ordenata[i].Enabled:=false;
            for i:=0 to g_num_ord_aula -1 do
                begin
                    if i<= high(g_cursos[aula].cgrupos) then
                        if g_cursos[aula].cgrupos[i]=grupo then
                           if equipoalumno[i].EstadoActivadEquipo<>eAveriado then
                                  Ordenata[i].Enabled:=true;
                end;
            for i:=0 to g_num_ord_aula -1 do
                begin
                    if  Ordenata[i].Enabled= false then
                        begin
                            ordenata[i].Picture.Bitmap.clear;
                            imldisabled.GetBitmap(0,Ordenata[i].Picture.bitmap);
                            lblOrdenata[i].Visible:=false;
                            spDarRaton[i].Enabled:=false;
                        end;
                end;
                lblgrupo.Caption:=f_NombreMigrupo+': '+ g_cursos[aula].nombregrupos[grupo];
                f_grupo:=true;
                btnandar.Caption:=CAPTION_BOTONES_ACTIVOSG[f_PantallaActiva];
                btnparar.Caption:=CAPTION_BOTONES_INACTIVOSG[f_PantallaActiva];
    end;

procedure TfrmMain.CargarSubgruposAlumnos(aula:integer);
    var
       numgrupos,i:integer;
       icogrupo:integer;
    begin
        numgrupos:=high(spGrupos);
        for i:=0 to numgrupos do
            spGrupos[i].Visible:=false;
        for i:=0 to g_Cursos[aula].numerogrupos -1 do
            begin
                icogrupo:=i mod 3;
                icogrupo:=icogrupo+47;
                if i>numgrupos then breaK;
                with spgrupos[i] do
                    begin
                        Glyph.Canvas.Rectangle(0,0,20,20);
                        Visible:=true;
                        Hint:=g_Cursos[aula].nombregrupos[i];
                        imlmenu.GetBitmap(icogrupo,Glyph);
                        Cursor:=crHandPoint;
                        tag:=i
                    end;

             end;
        if i < numgrupos then
            begin
               with spgrupos[i+1] do
                  begin
                      Glyph.Canvas.Rectangle(0,0,20,20);
                      Glyph.clear;
                      Visible:=true;
                      Hint:='Todos';
                      Down:=true;
                      imlmenu.GetBitmap(32,Glyph);
                      Cursor:=crHandPoint;
                      tag:=-1;
                  end;
            end;

    end;
Procedure TfrmMain.CargarNombresAlumnos();
    var
        j:integer;
        texeti:string;
    begin
        try
            f_NombreMigrupo:=g_Cursos[f_miaula].nombre;
            g_GrupoPertenece:=true;
            for j:=0 to g_num_ord_aula -1 do
                begin
                     if j < g_Cursos[f_miaula].numeroalumnos then
                        begin
                            texeti:= g_Cursos[f_miaula].nombrealumnos[j];
                            if trim(texeti)<>'' then
                                lblOrdenata[j].Caption:=texeti
                            else
                               lblOrdenata[j].Caption:=NombreUsuarioOrdenador(j);
                               equipoAlumno[j].NombreMiembroGrupo:=g_Cursos[f_miaula].nombrealumnos[j];
                        end ;
                end;
            lblgrupo.Caption:=f_NombreMigrupo;
        except
               mensaje(MEN_ERROR_GRUPOS,aceptar);
        end;
   end;

procedure TfrmMain.menuaulasclick(sender: Tobject);
    var
        i:integer;
    begin
       try
           f_MostrarUsuarios:=false;
           for i:=0 to g_num_ord_aula -1 do
            begin
                lblOrdenata[i].Visible:=true;
                Ordenata[i].Enabled:=true;
                lblmesa[i].Visible:=true
            end;
        comprobarEstadoOrdenadores(f_PantallaActiva);
        f_miaula:=(sender as Tmenuitem).tag;
        CargarNombresAlumnos();
        CargarSubgruposAlumnos(f_miaula);
        except
           mensaje(MEN_ERROR_GRUPOS, aceptar);
        end
    end;

procedure TfrmMain.CargarGruposAlumnos();
    var
        icogrupo,i:integer;
    begin
        try
            if (not fileexists(equipoProfesor.ArcCursos)) or (not LeerFicheroCursos())  then exit;
            mnugrupos.Clear;
            setlength(menusaulas,g_NumCursos);
            for i:=0 to g_NumCursos -1 do
                begin
                    icogrupo:=i mod 3;
                    icogrupo:=icogrupo+47;
                    menusaulas[i]:=Tmenuitem.create(self);
                    with menusaulas[i] do
                        begin
                            Caption:=g_Cursos[i].nombre;
                            Hint:=g_Cursos[i].nombre;
                            ImageIndex:=icogrupo;
                            OnClick:=@menuaulasclick;
                            tag:=i;
                        end;

                     mnugrupos.Add(menusaulas[i]);
                end;
        except
              mensaje(MEN_ERROR_GRUPOS, aceptar);
        end;
    end;
procedure TfrmMain.ActualizarMonitores;
        var
            i:integer;
        begin
            for i:=0 to g_num_ord_aula -1 do
                begin
                    lblOrdenata[i].Caption:=NombreUsuarioOrdenador(i);
                    if f_MostrarUsuarios=true then
                    Case f_PantallaActiva of
                        0:PintarMonPant0(i);
                    else
                        PintarMonPantOtros(i);
                    end;
                    RevisarGruposActivos(i);
                end;
            application.ProcessMessages;
        end;

procedure TfrmMain.ExamenActivo();
   begin
       imgExamen.visible:=true;
       lblExamen.visible:=true;
       tmrExamen.enabled:=true;
   end;

procedure TfrmMain.ExamenFinalizado();
   begin
       imgExamen.visible:=false;
       lblExamen.visible:=false;
       tmrExamen.enabled:=false;
   end;

procedure TfrmMain.RefrescarRecogidos(var combo:TcomboBox;directorio:string);
    var
        SearchRec: TSearchRec;
        DirRecibidos:string;
        CurAsi:string;
    begin
        with combo do
            begin
                Items.BeginUpdate;
                Sorted:=true;
                Clear;
            end;
        try
            if directorio<>'' then
                DirRecibidos:=equipoProfesor.HomeProfesor+'/recibidos/'+directorio+'/*'
            else
                DirRecibidos:=equipoProfesor.HomeProfesor+'/recibidos/*';
            if FindFirst(DirRecibidos, faAnyFile, SearchRec) = 0 then
                try
                    repeat
                        if SearchRec.Attr and faDirectory > 0 then
                            begin
                                if (SearchRec.Name <>'.') and  (SearchRec.Name <>'..') then
                                begin
                                    CurAsi := Format('%s', [SearchRec.Name]);
                                    combo.Items.Add(CurAsi)
                                end;
                            end;
                    until FindNext(SearchRec) <> 0
                finally
                    FindClose(SearchRec)
                end;
        finally
            combo.Items.EndUpdate
        end
    end;

procedure TfrmMain.RecargarAplicaciones();
    var
        i:integer;
    begin
        LeerSetupProfe;
        for i:=0 to 7 do
            begin
                rbapl[i].Caption:=g_NombreAplicacion[i+1];
                rbApl[i].font.Color:=clblack ;
            end;
    end;

procedure TfrmMain.rbAplClick(sender:Tobject);
    var
        i:integer;
    begin
        f_NumeroAplicacion:=(sender as Tradiobutton).Tag;
        for i:= low(rbApl) to high(rbApl) do
            rbApl[i].font.Color:=clblack ;
        rbApl[f_NumeroAplicacion].font.Color:=rgb(53,89,214);
    end;

procedure TfrmMain.PintarMonPantOtros(numEquipo:integer);
    var
        icono:integer;
    begin
        icono:=equipoAlumno[numEquipo].IconoEquipo(f_PantallaActiva);
        pgOrdenata[numEquipo].visible:=false;
        if lblOrdenata[numequipo].visible=false then exit;
        with ordenata[numEquipo] do
            begin
                Picture.Bitmap.clear;
                if (equipoAlumno[numEquipo].EstadoActivadEquipo in [eUsuario])then
                    begin
                        cursor:=crHandPoint;
                        enabled:=true;
                        Case icono of
                            0: imlIcoIna.GetBitmap(f_PantallaActiva,Picture.Bitmap);
                            1: imlIcoAct1.GetBitmap(f_PantallaActiva,Picture.Bitmap);
                       end;
                    end
                else
                    begin
                        Case icono of
                            2:imlIcoDis.GetBitmap(0,Picture.Bitmap);
                            0,1:imldisabled.GetBitmap(f_PantallaActiva,Picture.Bitmap);
                        end;
                        cursor:=crarrow;
                        enabled:=false;
                    end
            end;
       tmrBarra[numEquipo].Enabled:=pgOrdenata[numEquipo].Visible;
    end;

procedure TfrmMain.PintarMonPant0(numEquipo:integer);
    var
        estado:TEstadoActividadEquipo;
    begin
        pgOrdenata[numEquipo].visible:=false;
        estado:=equipoAlumno[numequipo].EstadoActivadEquipo;
        if lblOrdenata[numequipo].visible=false then exit;
        with ordenata[numEquipo] do
            begin
                Picture.Bitmap.clear;
                Case estado of
                   eApagado:
                      begin
                         imlEncender.GetBitmap(0,Picture.Bitmap);
                         cursor:=crHandPoint;
                         enabled:=true;
                      end;
                   eEncendiendo:
                      begin
                         imlEncender.GetBitmap(1,Picture.Bitmap);
                         cursor:=crHourGlass;
                         enabled:=false;
                         pgOrdenata[numEquipo].ForeColor:=clYellow;
                         pgOrdenata[numEquipo].MaxValue:=50;
                         pgOrdenata[numEquipo].Progress:=0;
                         pgOrdenata[numEquipo].visible:=true;
                      end;
                   eEncendido:
                      begin
                         imlEncender.GetBitmap(2,Picture.Bitmap);
                         cursor:=crHandPoint;
                         enabled:=true;
                      end;
                   eUsuario:
                      begin
                         imlEncender.GetBitmap(3,Picture.Bitmap);
                         cursor:=crHandPoint;
                         enabled:=true;
                      end;
                   eApagando:
                      begin
                         imlEncender.GetBitmap(4,Picture.Bitmap);
                         cursor:=crHourGlass;
                         enabled:=false;
                         pgOrdenata[numEquipo].ForeColor:=clRed;
                         pgOrdenata[numEquipo].MaxValue:=10;
                         pgOrdenata[numEquipo].Progress:=0;
                         pgOrdenata[numEquipo].visible:=true;
                      end;
                    eAveriado:
                      begin
                         imlEncender.GetBitmap(5,Picture.Bitmap);
                         cursor:=crDefault;
                         enabled:=false;
                      end;
                end;
            end;
        tmrBarra[numEquipo].Enabled:=pgOrdenata[numEquipo].Visible;
    end;

procedure TfrmMain.IniciarPelicula();
     const
        ORD_INICIAR_PELI:string='vlc --volume 1024 %s --sout udp:%s --sout-keep --sout-all --audio-desync 1000 --ttl 5 &';
        ORD_INICIAR_PELIDVD:string='vlc --volume 1024 %s --sout udp:%s --sout-keep --sout-all --audio-desync 1000 --ttl 5 &';
     var
        i,tipvlc:integer;
        orden_inicio_peli:string;
        orden_inicio_dvd:string;
        orden_inicio_vcd:string;
    begin

        tipvlc:=0;
        for i:=0 to pnTipoVlc.ControlCount -1 do
              if pnTipoVlc.controls[i] is Tradiobutton then
                      if (pnTipoVlc.controls[i] as Tradiobutton).Checked =true  then
                              tipvlc:=(pnTipoVlc.controls[i] as Tradiobutton).tag;
        if (tipvlc=0) and (length(edNomVlc.text)<5) then
            begin
                mensaje(MEN_SELECIONE_VIDEO,aceptar);
                btnIniciar.Enabled:=true;
                btnDetener.Enabled:=false;
                exit;
            end;
        case tipvlc of
            0:ordenesaula(ORD_INICIAR_PELI,[edNomVlc.text,g_ipvlc]);
            1:ordenesaula(ORD_INICIAR_PELIDVD,['dvdsimple:///dev/dvd',g_ipvlc]);
            2:ordenesaula(ORD_INICIAR_PELIDVD,['vcd:///dev/cdrom',g_ipvlc])
        end;
        application.ProcessMessages;
        Ejecutar('vlc udp:@' +g_ipvlc+ ' &');
    end;

Procedure TfrmMain.HallarMac;
    const
        BUSCAR_MAC:STRING='grep -i %s  /tmp/ndns.txt | cut -f2 -d" "';
        BUSCAR_NOMBRE:STRING='grep -i -c %s /tmp/ndns.txt';
    var
       ordennombre, ordenmac:string;
       i,ordena:integer;
    begin
        for i:=0 to g_num_ord_aula -1 do
            begin
                ordennombre:=format(BUSCAR_NOMBRE,[equipoAlumno[i].IP]);
                ordennombre:=trim(HallarDato(ordennombre));
                if ordennombre='' then
                    ordena:=0
                else
                    ordena:=strtoint(ordennombre);
                if ordena > 0 then
                    begin
                        ordenmac:=format(BUSCAR_MAC,[equipoAlumno[i].IP]);
                        equipoAlumno[i].MAC:=trim(HallarDato(ordenmac));
                     end
                else
                    begin
                        equipoAlumno[i].MAC:='00:00:00:00:00:00';
                    end
            end
    end;

Procedure TfrmMain.HallarEquiposDnsMasq(malumno:string;numor:integer;var numequipos:integer);

    const
        BUSCAR_MAC:STRING='grep -i %s  /tmp/ndns.txt | cut -f2 -d" "';
        BUSCAR_NOMBRE:STRING='grep -i -c %s /tmp/ndns.txt';
    var
       ordennombre, ordenmac:string;
       ordena:integer;
    begin
        ordennombre:=format(BUSCAR_NOMBRE,[malumno]);
        ordennombre:=trim(HallarDato(ordennombre));
        if ordennombre='' then
        ordena:=0
        else
        ordena:=strtoint(ordennombre);
        if ordena > 0 then
            begin
                ordenmac:=format(BUSCAR_MAC,[malumno]);
                numequipos:=numor+1;
                equipoAlumno[ordena].MAC:=trim(HallarDato(ordenmac));
            end
        else
            begin
                equipoAlumno[numor].MAC:='00:00:00:00:00:00';
            end
    end;

procedure TfrmMain.EliminarRecibidos();
    var
       carpetaeliminar:string;
    begin
       carpetaeliminar:=equipoProfesor.HomeProfesor+'/recibidos';
       if cboasidev.ItemIndex<>-1 then
           begin
               carpetaeliminar:=carpetaeliminar+'/'+cboasiDev.text;
               if cbocurdev.ItemIndex<>-1 then
                   carpetaeliminar:=carpetaeliminar+'/'+cbocurdev.text;
           end;
       if mensaje(MEN_LIMPIAR_DEVUELTOS + carpetaeliminar+ MEN_CONTINUAR,sino)=1 then
           begin
               Ejecutar('rm -r '+ carpetaeliminar);
               cbocurdev.ItemIndex:=-1;
               cboAsidev.ItemIndex:=-1;
           end;
    end;

procedure TfrmMain.EscaparRaton();
    var
        i: integer;
    begin
        for i:=0 to g_num_ord_aula -1 do
        if (spDarRaton[i].Down=true) and equipoAlumno[i].poseoRaton then
            begin
                equipoAlumno[i].poseoRaton:=false;
                AlumnoRatonNo(i);
                spDarRaton[i].Down:=false
            end;
    end;

Procedure TfrmMain.AlumnoVlcNo(ord_num:integer);
    begin
        EjecutarOrdenesFin(ord_num,false,chkVlc.Checked,'Aviso',meVlc.text);
         chkVlc.Checked:=false;
    end;

procedure TfrmMain.AlumnoVlc(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,true,chkVlc.Checked,'Aviso',meVlc.text);
         chkVlc.Checked:=false;
    end;

procedure TfrmMain.AlumnoVerNo(ord_num:integer);
    begin
        EjecutarOrdenesFin(ord_num,false,chkVer.Checked,edAsuVer.text,meVer.text);
        chkVer.Checked:=false;
    end;
Function TfrmMain.tipoObservacion():integer;
    var
        i,tipo:integer;
    begin
        tipo:=0;
        for i:=0 to pnTipo.ControlCount -1 do
            if pnTipo.controls[i] is Tradiobutton then
                if (pnTipo.controls[i] as Tradiobutton).Checked =true  then
                    tipo:=(pnTipo.controls[i] as Tradiobutton).tag;
        result:=tipo;
    end;

procedure TfrmMain.AlumnoVer(ord_num:integer;presenta:boolean=false);
    begin
        g_tipoobservacion:= tipoObservacion();
        if presenta then g_tipoobservacion:=0;
        g_modoobservacion:=ord_num;
        Ejecutar(ORD_APAGA_XVNC);
        EjecutarOrdenesFin(ord_num,true,chkVer.Checked,edAsuVer.text,meVer.text);
        chkVer.Checked:=false;
    end;
procedure TfrmMain.AlumnoTecladoRatonSi(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,false,chkTec.Checked,edAsuTec.Text,meTec.text);
         chkTec.Checked:=false;
    end;

procedure TfrmMain.AlumnoTecladoRatonNo(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,true,chkTec.Checked,edAsuTec.Text,meTec.text);
         chkTec.Checked:=false;
    end;

procedure TfrmMain.AlumnoRecibirNo(ord_num:integer);
    begin
        AlumnoMensajeNo(ord_num);
    end;

procedure TfrmMain.AlumnoRecibir(ord_num:integer);
    begin
         g_carpeta_recibir_path:=equipoProfesor.DirRecibidos+PathDelim+cboasirec.Text+PathDelim+cborec.Text;
        if not DirectoryExists(g_carpeta_recibir_path) then
                forcedirectories(g_carpeta_recibir_path);
         g_mensaje_asunto:=TIdURI.ParamsEncode('Aviso');
         g_mensaje_texto:=TIdURI.ParamsEncode(meTexRec.text);
         EjecutarOrdenesFin(ord_num,true)
    end;

procedure TfrmMain.AlumnoRatonNo(ord_num:integer);
    begin
        if equipoalumno[ord_num].iconoEquipo(f_PantallaActiva)=1 then
            begin
                equipoAlumno[ord_num].ElegirOrden(14,false);
                f_AmoRaton:=-1;
            end;
    end;

procedure TfrmMain.AlumnoRatonSi(ord_num:integer);
    begin
        if (f_AmoRaton<> -1) and (f_AmoRaton<>ord_num) then AlumnoRatonNo(f_AmoRaton);
        if equipoalumno[ord_num].iconoEquipo(f_PantallaActiva)=1 then
            begin
                f_AmoRaton:=ord_num;
                equipoAlumno[ord_num].ElegirOrden(14,true);
            end;
    end;

procedure TfrmMain.AlumnoPresentacionNo(ord_num:integer);
    var
       i:integer;
    begin
        cambiariconoinactivo(ord_num);
        equipoAlumno[ord_num].verNo;
        f_AlumnoPresentado:=false;
        equipoAlumno[ord_num].ElegirOrden(f_PantallaActiva,false);
        for  i:=0 to high(equipoAlumno) do
             equipoAlumno[i].mostrarNo;
    end;

procedure TfrmMain.VerPresentador(ord_num:integer);
    begin
        equipoalumno[ord_num].presentar();
        application.ProcessMessages;
    end;

procedure TfrmMain.AlumnoPresentacion(ord_num:integer);
    var
        i:integer;
    begin
        if f_AlumnoPresentado then
            begin
                application.ProcessMessages;
                equipoAlumno[f_OrdenadorPresentado].verNo;
                equipoAlumno[f_OrdenadorPresentado].fIconoMonitor[f_PantallaActiva]:=0;
                cambiariconoinactivo(f_OrdenadorPresentado);
            end;
        application.ProcessMessages;
        VerPresentador(ord_num);
        application.ProcessMessages;
        for  i:=0 to high(equipoAlumno) do
                if (i<> ord_num) then equipoAlumno[i].mostrar();
        if chkPresentacion.Checked then
            begin
                g_mensaje_prioridad:='0';
                g_mensaje_asunto:=edPresentacion.text;
                g_mensaje_texto:=mePresentacion.text;
                equipoAlumno[ord_num].mensaje();
                chkPresentacion.Checked:=false;
            end;
        f_OrdenadorPresentado:=ord_num;
        f_AlumnoPresentado:=true;
        cambiariconoactivo(ord_num);
    end;

Procedure TfrmMain.AlumnoNavegarNo(ord_num:integer);
    begin
        EjecutarOrdenesFin(ord_num,false);
    end;

procedure TfrmMain.AlumnoNavegar(ord_num:integer);
    begin
         g_webnavegar:=edpagina.text;
         EjecutarOrdenesFin(ord_num,true)
    end;

Procedure TfrmMain.AlumnoMostrar(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,true,chkMostrar.Checked,edMostrar.Text,meMostrar.text);
         chkMostrar.Checked:=false;
    end;

procedure TfrmMain.AlumnoMostrarNo(ord_num:integer);
    begin
        EjecutarOrdenesFin(ord_num,false,chkMostrar.Checked,edMostrar.Text,meMostrar.text);
        chkMostrar.Checked:=false;
    end;

procedure TfrmMain.AlumnoMensaje(ord_num:integer);
    begin
         g_mensaje_prioridad:=PrioridadMensaje;
         g_mensaje_asunto:=TIdURI.ParamsEncode(edasumen.text);
         g_mensaje_texto:=TIdURI.ParamsEncode(metexmen.text);
         EjecutarOrdenesFin(ord_num,true)
    end;
Function TfrmMain.PrioridadMensaje:string;
    var
        i,nprio:integer;
    begin
        nprio:=0;
        for i:=0 to pnprioridad.ControlCount -1 do
            if pnprioridad.controls[i] is Tradiobutton then
                if (pnprioridad.controls[i] as Tradiobutton).Checked =true  then
                        nprio:=(pnprioridad.controls[i] as Tradiobutton).tag;
        result:=inttostr(nprio)
    end;
procedure TfrmMain.AlumnoInternetNo(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,true,chkDesactivar.Checked,edDesactivar.Text,meDesactivar.text);
         chkDesactivar.Checked:=false;
    end;

procedure TfrmMain.AlumnoInternetSi(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,false,chkDesactivar.Checked,edDesactivar.Text,meDesactivar.text);
         chkDesactivar.Checked:=false;
    end;

procedure TfrmMain.AlumnoDevolverNo(ord_num:integer);
    begin
        AlumnoMensajeNo(ord_num);
    end;

procedure TfrmMain.AlumnoDevolver(ord_num:integer);
    begin
         g_mensaje_asunto:=TIdURI.ParamsEncode('Aviso');
         g_mensaje_texto:=TIdURI.ParamsEncode(meArcDev.text);
         g_carpeta_devolver_path:=equipoProfesor.DirRecibidos+PathDelim+cboAsiDev.text+PathDelim+cboCurDev.text;
         g_carpeta_devolver_nombre:=cboAsiDev.text;
         EjecutarOrdenesFin(ord_num,true)
    end;

procedure TfrmMain.AlumnoCarpetaNo(ord_num:integer);
    begin
        AlumnoMensajeNo(ord_num);
    end;

procedure TfrmMain.AlumnoCarpeta(ord_num:integer);
    begin
         g_mensaje_asunto:=TIdURI.ParamsEncode('Aviso');
         g_mensaje_texto:=TIdURI.ParamsEncode(meCarpertas.text);
         EjecutarOrdenesFin(ord_num,true)
    end;

procedure TfrmMain.AlumnoMensajeNo(ord_num:integer);
    begin
        EjecutarOrdenesFin(ord_num,false);
    end;

procedure TfrmMain.AlumnoArchivoNo(ord_num:integer);
    begin
        AlumnoMensajeNo(ord_num);
    end;

procedure TfrmMain.AlumnoAplicacion(ord_num,tipo_aplicacion:integer);
    begin
         g_nombreAplicacion1:=g_ComandoAplicacion[tipo_aplicacion+1];
         EjecutarOrdenesFin(ord_num,true);
    end;

procedure TfrmMain.AlumnoAplicacionNo(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,false);
    end;

procedure TfrmMain.AlumnoArchivo(ord_num:integer);
   begin
         g_archivo_path:=fnArchivo.filename;
         g_mensaje_asunto:=TIdURI.ParamsEncode('Aviso');
         g_mensaje_texto:=TIdURI.ParamsEncode(meTexArc.text);
         EjecutarOrdenesFin(ord_num,true)
    end;
procedure TfrmMain.AlumnoEncender(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,true)
    end;

procedure TfrmMain.AlumnoEncenderNo(ord_num:integer);
    begin
         EjecutarOrdenesFin(ord_num,false);
    end;

Procedure TfrmMain.ColocarPaneles();
    var
        j,i:integer;
        cnt:Tcontrol;
    begin
        for i:=0 to controlcount-1 do
            begin
                if (controls[i] is TPanel) and ((controls[i] as Tpanel).Tag=20) then
                    begin
                       (controls[i] as TPanel).SetBounds(L_GROUPBOX,T_GROUPBOX,W_GROUPBOX,H_GROUPBOX);
                       (controls[i] as TPanel).color:=RGB(245,245,245);
                       for j:=0 to  (controls[i] as TPanel).ControlCount-1 do
                            begin
                               cnt:=(controls[i] as TPanel).controls[j];
                               cnt.setbounds(cnt.Left,cnt.top,cnt.Width,cnt.Height);
                            end;
                    end;
            end;
    end;

procedure TfrmMain.OcultarMenus;
    var
        i:integer;
    begin
        for i:=0 to self.componentcount-1 do
            if (components[i] is TmenuItem) then (components[i] as TmenuItem).visible:=false;
    end;

procedure TfrmMain.MostrarMenus;
    var
        i:integer;
    begin
        for i:=0 to self.componentcount-1 do
            if (components[i] is TmenuItem) then (components[i] as TmenuItem).visible:=true;
        mnuCanon.visible:=g_CanonActivo;
        mnuFotosNoVer.visible:=false;
        mnuFotosVer.visible:=g_fotos_existen;


    end;

procedure TfrmMain.FormCreate(Sender: TObject);
    const
        ORDEN_CREAR_CONTRA='aulaconlinext 02101067 %s &';
        DIR_AULALINEX_PROFESOR:string='/var/lib/aulalinex-profesor-ltsp';
        GRUPO_PROFESORES:string='groups|grep profesor';
        AULACONFIGURAR:string='cat /var/lib/aulalinex-profesor-ltsp/setup.ini | grep -v grep | grep -c "Mesa 01=192.168.0.1"';
    var
       ordencontra:string;
       bnotaulaconfigurada:Boolean;
       btempsetupini:Boolean;
    begin
        CerrarServidorVnc();
        Application.Icon:=frmMain.Icon;
        top:=13;left:=(screen.Width-width) div 2;
        f_PantallaActiva:=0;
        g_fotos_existen:=DirectoryExists('/home/instituto/.fotos');
        OcultarMenus();
        ColocarPaneles();
        pnPresenta.align:=alClient;
        pnPresenta.bringtoFront;
        imgPresentacion.align:=alClient;
        Randomize();
        pnfondo.align:=alclient;
        if not fileexists(DIR_SETUP_AULALINEX) then
        begin
           mensaje('No existe '+ DIR_SETUP_AULALINEX, aceptar);
           Application.Terminate;
        end;
        application.processmessages;
        application.Icon:=frmMain.Icon;
        equipoprofesor:=TEquipoProfe.create();
        CargarDatosAula();

       if (length(Hallardato(GRUPO_PROFESORES))=0) and (equipoProfesor.UsuarioProfesor<>'root') then
            begin
                mensaje(MEN_SOLO_PROFES,aceptar);
                application.Terminate;
                exit;
            end;
        if not DirectoryExists(DIR_AULALINEX_PROFESOR) THEN
            begin
               mensaje(MEN_ERROR_NO_INSTALADO,aceptar);
               application.Terminate;
               exit;
            end;
        bnotaulaconfigurada:=(HallarDato(AULACONFIGURAR)='1');
        btempsetupini:= fileexists(DIR_TEMP_SETUP_AULALINEX);
        if btempsetupini and bnotaulaconfigurada then
            g_archivo_configuracion_aulalinex:= DIR_TEMP_SETUP_AULALINEX
        else
            g_archivo_configuracion_aulalinex:= DIR_SETUP_AULALINEX;
        if fileexists(g_archivo_configuracion_aulalinex) then
                CargarConfiguracionAula(g_archivo_configuracion_aulalinex);
        CargarConfiguracionUsuario();
        ordencontra:=Format(ORDEN_CREAR_CONTRA,[equipoProfesor.ArcContraVNC]);
        ejecutar(ordencontra);
        IniciarPrograma();
        timer2.Enabled:=true;
        Ficheros:=TStringList.Create;
        Application.ProcessMessages;
        IniciarRelojes();
        iniciarvnc(-1);
        mnuFotosVer.Visible:=g_fotos_existen;
        mnuFotosNoVer.visible:=false;
    end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
    begin
       // if (f_PantallaActiva =2) and (key = VK_Cancel ) then
           // EscaparRaton;
    end;

procedure TfrmMain.imgPanelCanonClick(Sender: TObject);
    begin
        imgPanelCanon.Enabled:=false;
        g_PanelCanon:=true;
        g_Display:='1';
    end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    const
        P_VLC:string='vlc';
    begin
        if mensaje(MEN_SALIR,sino) = 2 then
            canclose:=false
        else
            begin
                 hide;
                 application.processmessages;
                 timer2.Enabled:=false;
                 g_apagando:=true;
                 CerrarServidorVnc();
                 ordenesaula(ORD_APAGAR_EN_PROFE,[P_XVNC]);
                 ordenesaula(ORD_APAGAR_EN_PROFE,[P_VLC]);
                 if g_Examinando then
                    if Assigned(frmExamen) then
                        frmExamen.close;
            end;
    end;

procedure TfrmMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        try
            if IdCmdTCPServer1.Active=true then
               IdCmdTCPServer1.active:=false;
               if Ficheros<> nil then
                 Ficheros.free;
        except
                //
        end
    end;

procedure TfrmMain.btnAndarClick(Sender: TObject);
    begin
        if ValidarContenido(f_PantallaActiva)=false then exit;
        OrdenEjecutarTodos(f_PantallaActiva);
    end;

procedure TfrmMain.btnCargarWebClick(Sender: TObject);
    begin
        opendialog3.Filter:=FILTRO_TXT;
        if opendialog3.execute then
            begin
                lstPag.Items.LoadFromFile(opendialog3.FileName);
                btnFavoritos.Enabled:=true;
                btnGuardarF.Enabled:=true;
            end;
    end;

procedure TfrmMain.btnCarImaClick(Sender: TObject);
    begin
        //
    end;

procedure TfrmMain.btnCarVlcClick(Sender: TObject);
    const
        FILTRO_VIDEO:string='Video ( *.mpg,*.mpeg,*.avi)|*.mpg; *.mpeg;*.avi|Audio(*.ogg,*.mp3)|*.ogg;*.mp3 |Todos los Archivos(*.*)|*.*';
    begin
        with Topendialog.create(nil) do
            begin
                Filter:=FILTRO_VIDEO;
                if  Execute then
                    begin
                        ednomvlc.Text:='"'+ FileName +'"';
                        btniniciar.Enabled:=true;
                        btndetener.Enabled:=false;
                    end;
                free;
            end;
    end;

procedure TfrmMain.btnDetenerClick(Sender: TObject);
    const
        ORD_APAGA_VLC:string='killall vlc & 2>> /dev/null';
    begin
        OrdenRestablecerTodos(f_pantallaActiva);
        Ejecutar(ORD_APAGA_VLC);
        btniniciar.Enabled:=true;
        btndetener.Enabled:=false;
    end;

procedure TfrmMain.btnEleMen1Click(Sender: TObject);
    begin
        OpenDialog3.Filter:=FILTRO_TXT;
        if OpenDialog3.Execute then
        meTexArc.Lines.LoadFromFile(OpenDialog3.filename);
    end;

procedure TfrmMain.btnEleMenClick(Sender: TObject);
    begin
        opendialog3.Filter:=FILTRO_TXT;
        if opendialog3.execute then
            meTexMen.lines.LoadFromFile(opendialog3.FileName);
    end;

procedure TfrmMain.btnEliPagClick(Sender: TObject);
    begin
        if lstpag.ItemIndex<>-1 then
            begin
                lstpag.Items.Delete (lstpag.ItemIndex);
                btnGuardarF.Enabled:=true;
                btnFavoritos.Enabled:=true;
            end;
    end;

procedure TfrmMain.btnEliRecClick(Sender: TObject);
    begin
       EliminarRecibidos;
       cboAsiDev.text:='';
       cboCurDev.clear;
    end;

procedure TfrmMain.btnFavoritosClick(Sender: TObject);
    begin
        if FileExists(equipoProfesor.ArcFavoritosWeb) then
            lstPag.Items.LoadFromFile(equipoProfesor.ArcFavoritosWeb);
        btnFavoritos.Enabled:=false;
    end;

procedure TfrmMain.btnGuardarFClick(Sender: TObject);
    begin
        if mensaje(MEN_GUARDAR_FAVORITOS,sino)=1 then
            lstPag.Items.savetofile(equipoProfesor.ArcFavoritosWeb)
    end;

procedure TfrmMain.btnIniciarClick(Sender: TObject);
    begin
        btniniciar.Enabled:=false;
        btndetener.enabled:=true;
        IniciarPelicula();
    end;

procedure TfrmMain.Administrador1Click(Sender: TObject);
    var
       i:integer;
    begin
        application.ProcessMessages;
        if mensaje(MEN_CONTRA_ADMINISTRADOR,sino)= 1 then
            begin
                for i:=0 to g_num_ord_aula -1 do
                    equipoalumno[i].pararRelojPing(false);
                application.ProcessMessages;
                TfrmConpro.Create(nil).ShowModal;
                for i:=0 to g_num_ord_aula -1 do
                    if equipoalumno[i].EstadoActivadEquipo<>eAveriado then
                       equipoalumno[i].pararRelojPing(true);
            end;
    end;

procedure TfrmMain.btnAnaPagClick(Sender: TObject);
    begin
        if length(trim(edpagina.Text))>5 then
            begin
                lstpag.Items.Add(trim(edpagina.Text));
                btnGuardarF.Enabled:=true;
                btnFavoritos.Enabled:=true;
            end;
    end;

procedure TfrmMain.btnPararClick(Sender: TObject);
    begin
        OrdenRestablecerTodos(f_PantallaActiva);
    end;

procedure TfrmMain.btnVerClick(Sender: TObject);
    var
        orden_verarchivos:string;
    begin
        if not DirectoryExists(equipoProfesor.HomeProfesor+'/recibidos') then
            Createdir(equipoProfesor.HomeProfesor+'/recibidos');
        orden_verarchivos:='nautilus ' + equipoProfesor.HomeProfesor+'/recibidos &';
        Ejecutar(orden_verarchivos);
    end;

procedure TfrmMain.Calculadora1Click(Sender: TObject);
    const
        P_CALCU:string='gnome-calculator';
    begin
        ordenesaula(ORD_EJECUTAR_EN_PROFE,[P_CALCU]);
    end;

procedure TfrmMain.cboAsiDevChange(Sender: TObject);
    begin
        with cbocurdev do
            begin
                RefrescarRecogidos(cbocurdev,cboasidev.text);
                Text:='';
                enabled:=true;
            end;
    end;

procedure TfrmMain.cboAsiDevKeyPress(Sender: TObject; var Key: char);
    begin
        key:=#0;
    end;

procedure TfrmMain.cboAsiRecKeyPress(Sender: TObject; var Key: char);
    begin
        key:=#0;
    end;

procedure TfrmMain.cboCurDevKeyPress(Sender: TObject; var Key: char);
    begin
        key:=#0;
    end;

procedure TfrmMain.deCarpetasChange(Sender: TObject);
    begin
        if directoryexists(deCarpetas.directory) then
            g_carpeta_enviar_path:=deCarpetas.directory;
    end;

procedure TfrmMain.FormDestroy(Sender: TObject);
    begin
       Ejecutar('killall aulalinex-profesor-ltsp &');
    end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
   IniciarServidorVnc();
end;

procedure TfrmMain.imgCanonClick(Sender: TObject);
    begin
        Application.CreateForm(TfrmCanon, frmCanon);
        frmCanon.ShowModal;
    end;

procedure TfrmMain.imgCanonMouseEnter(Sender: TObject);
    begin
        (sender as Timage).Picture.Bitmap.clear;
        imlCanon.GetBitmap(1,(sender as Timage).Picture.Bitmap);
    end;
procedure TfrmMain.imgCanonMouseLeave(Sender: TObject);
    begin
        (sender as Timage).Picture.Bitmap.clear;
        imlCanon.GetBitmap(0,(sender as Timage).Picture.Bitmap);
    end;

procedure TfrmMain.imgFondoPrincipalMouseEnter(Sender: TObject);
begin
        if pnFotos.visible then pnFotos.visible:=False;
end;

procedure TfrmMain.mnuFotosNoVerClick(Sender: TObject);
    var
        i:integer;
    begin
        if g_fotos_existen then
          begin
              g_mostrar_todas_fotos:=false;
              for i:=0 to g_num_ord_aula -1 do
                  begin
                      imgFotos[i].visible:=false;
                      imgFoto[i].visible:=(equipoalumno[i].EstadoActivadEquipo=eUsuario);
                  end;
               mnuFotosNoVer.visible:=false;
               mnuFotosVer.visible:=true;

          end;
    end;

procedure TfrmMain.mnuFotosVerClick(Sender: TObject);
    var
        i:integer;
    begin
        if g_fotos_existen then
          begin

              g_mostrar_todas_fotos:=true;
              for i:=0 to g_num_ord_aula -1 do
                  begin
                      RefrescarEquipoAulaNuevo(i,equipoAlumno[i].EstadoActivadEquipo,equipoAlumno[i].UsuarioActivo);
                      Application.ProcessMessages;
                  end;
               mnuFotosNoVer.visible:=true;
               mnuFotosVer.visible:=false;
          end;
    end;
procedure TfrmMain.mnuDevExaClick(Sender: TObject);
    var
       examen:string;
    begin
       SelectDirectoryDialog1.InitialDir:=equipoProfesor.DirExaCorregidos;

       if SelectDirectoryDialog1.Execute then
         begin
             examen:=ExtractFileName(SelectDirectoryDialog1.filename);
             if mensaje('¿Desea devolver el examen '+ examen + ' corregido?',sino)=1 then
                    DevolverExamen(examen);
         end;

    end;

procedure TfrmMain.mnuEjemploClick(Sender: TObject);
    const
        CURSO_EJEMPLO:string='Biología y Gelogia: 3ºF';
    var
      i:integer;
    begin
        g_GrupoPertenece:=true;
        for i:= 0 to g_num_ord_aula-1 do
            begin
                lblOrdenata[i].Caption:=ALUMNOS_EJEMPLO[i];
                equipoAlumno[i].NombreMiembroGrupo:=ALUMNOS_EJEMPLO[i];
            end;
        for i:=g_num_ord_aula to g_num_ord_pantalla-1 do
            lblOrdenata[i].Caption:='';
        lblgrupo.Caption:=CURSO_EJEMPLO;
    end;

procedure TfrmMain.mnuExamenClick(Sender: TObject);
    begin
        mnuRefrescarClick(mnuRefrescar);
        Application.CreateForm(TfrmExamen, frmExamen);
        frmExamen.ShowModal;
    end;

procedure TfrmMain.fnArchivoChange(Sender: TObject);
    begin
        if fileexists(fnArchivo.filename) then
            g_archivo_nombre:=ExtractFilename(fnArchivo.filename);
    end;

Procedure TfrmMain.DesmarcarMenus();
    var
        i:integer;
    begin
        for i:=0 to ComponentCount-1 do
            if (Components[i] is Tmenuitem) then (Components[i] as Tmenuitem).checked:=false;
    end;

procedure TfrmMain.MenusClick(MenuPulsado:Tmenuitem;PantallaNumero:integer;GbParametros:TPanel;BotonHerramientas:Tspeedbutton);
    begin
        if (f_PantallaActiva <>0) then
            if TodosApagados then exit;
        MostrarPanel(GbParametros);
        ActualizarMonitores();
        DesmarcarMenus();
        MenuPulsado.Checked:=true;
        ComprobarEstadoOrdenadores(PantallaNumero);
        BotonHerramientas.Down:=true;
    end;

Procedure TfrmMain.ComprobarEstadoOrdenadores(numero_pantalla:integer);
    var
        j:integer;
    begin
        lblinfo.Caption:=NOMBRE_PANTALLA[numero_pantalla];
        if not f_grupo then
            begin
                btnAndar.Caption:=CAPTION_BOTONES_ACTIVOS[numero_pantalla];
                btnparar.Caption:=CAPTION_BOTONES_INACTIVOS[numero_pantalla];
            end
        else
            begin
                btnAndar.Caption:=CAPTION_BOTONES_ACTIVOSG[numero_pantalla];
                btnparar.Caption:=CAPTION_BOTONES_INACTIVOSG[numero_pantalla];
            end;
        btnparar.Enabled:=true;
        btnandar.Enabled:=true;
        pintarlogos(numero_pantalla);
        for j:=0 to g_num_ord_aula-1 do
            begin
                 RefrescarEquipoAulaNuevo(j,equipoAlumno[j].EstadoActivadEquipo,equipoAlumno[j].UsuarioActivo);
                 Application.ProcessMessages;
            end;
    end;

procedure TfrmMain.MostrarPanel(gb:TPanel);
    var
        i:integer;
    begin
        if (gb as TPanel).Name<>'pnEnc' then
            gb.BringToFront;
        gb.Visible:=true;
        for i:=0 to g_num_ord_aula-1 do
            spdarraton[i].Visible:=(gb as TPanel).Name='pnMos';
        btnandar.visible:=not ((gb as TPanel).Name='pnAlu');
        btnparar.visible:=not ((gb as TPanel).Name='pnAlu');
        pnPresenta.Visible:=false;
    end;

Function TfrmMain.TodosApagados(const RevisarAlu:boolean=false;const mostrar_mensaje:boolean=true):boolean;
    var
        i:integer;
        inactivar:boolean;
    begin
       inactivar:=true;
       if (f_PantallaActiva <>0) or RevisarAlu or f_camara then
            begin
                for i:=0 to g_num_ord_aula -1 do
                    if (equipoalumno[i].EstadoActivadEquipo in [eUsuario] )then inactivar:=false;
                if inactivar then
                        begin
                            if mostrar_mensaje then
                            Mensaje(MEN_NO_ENCENDIDOS,aceptar);
                            f_PantallaActiva:=0;
                            spEnc.Down:=true;
                        end;
            end;
       f_camara:=false;
       result:=inactivar;
    end;

Procedure TfrmMain.IniciarPrograma();
    begin
        ModificarProgramas();
        CargarGruposAlumnos();
        IniciarVariables();
        CrearColocarComponentes();
        mnuaula.Visible:=false;
        ColocarPaneles();
        pintarlogos(f_PantallaActiva);
        imgCanon.visible:=g_CanonActivo;
        pnPresenta.BringToFront;
        Application.ProcessMessages;
    end;

procedure TfrmMain.pintarlogos(numero_pantalla:integer);
    begin
        with imgico do
            begin
                Stretch:=true;
                Picture.Bitmap.clear;
                imllogos.Getbitmap(numero_pantalla,picture.bitmap);
            end;
    end;

procedure TfrmMain.ModificarProgramas();
    var
        i:integer;
    begin
       for i:= low(rbapl) to high(rbapl) do
          rbApl[i].caption:= g_NombreAplicacion[i+1]
    end;

Procedure TfrmMain.IniciarVariables;
    var
        i:integer;
    begin
        setlength(imgFotos,g_num_ord_pantalla);
        setlength(imgFoto,g_num_ord_pantalla);
        setlength(tmrBarra,g_num_ord_pantalla);
        setlength(Ordenata,g_num_ord_pantalla);
        setlength(spDarRaton,g_num_ord_pantalla);
        setlength(lblOrdenata,g_num_ord_pantalla);
        SetLength(pgOrdenata,g_num_ord_pantalla);
        Setlength(lblmesa,g_num_ord_pantalla);
        setlength(spGrupos,g_num_ord_pantalla);
        setlength(rbapl,8);
        for i:=0 to g_num_ord_aula-1 do
            begin
                if  equipoProfesor.RatonTecladosInactivos then
                    begin
                       equipoAlumno[i].fMonitorPulsado[13]:=true;
                       equipoAlumno[i].fIconoMonitor[13]:=1;
                    end;
                if  equipoProfesor.AccesoInternetInactivo then
                    begin
                       equipoAlumno[i].fMonitorPulsado[12]:=true;
                       equipoAlumno[i].fIconoMonitor[12]:=1;
                    end;

            end;
    end;
Procedure TfrmMain.CrearColocarComponentes();
    var
       icogrupo,i:integer;
    begin
        for i:=g_num_ord_pantalla-1 downto 0 do
            begin
                Ordenata[i]:= TImage.Create(self);
                with Ordenata[i] do
                    begin
                        width:=W_ORDENADOR;
                        Height:=H_ORDENADOR;
                        stretch:=true;
                        Cursor:=crarrow;
                        imlicodis.GetBitmap(0,Picture.Bitmap);
                        Parent:=self;
                        tag:=i;
                        visible:=false;
                        OnClick:=@OrdenataClick;

                        if i< g_num_ord_aula then
                        if equipoalumno[i].EstadoActivadEquipo=eAveriado then
                            enabled:=false;
                    end;
            end;
        for i:=g_num_ord_pantalla-1 downto 0 do
            begin
                pgOrdenata[i]:= TColorProgress.Create(self);
                with pgOrdenata[i] do
                    begin
                        width:=W_ORDENADOR-12;
                        Height:=5;
                        ShowText:=false;
                        MaxValue:=60;
                        MinValue:=0;
                        Progress:=0;
                        ForeColor:=clYellow;
                        BackColor:=clBlack;
                        Cursor:=crHourGlass;
                        Parent:=self;
                        tag:=i;
                        visible:=false;
                    end;
            end;
        for i:=0 to g_num_ord_pantalla-1 do
            begin
                tmrBarra[i]:= TTimer.Create(self);
                with tmrBarra[i] do
                    begin
                        tag:=i;
                        onTimer:=@tmrBarraTimer;
                        interval:=1000;
                        enabled:=false;
                    end;
            end;

        if g_DisenoClase=0 then
            MostrarOrdenadores
        else
            MostrarPersonal;
        for i:= 0 to g_num_ord_pantalla-1 do
            begin
                  spdarraton[i]:= TspeedButton.Create(self);
                  with spdarraton[i] do
                      begin
                          GroupIndex:=101;
                          Down:=false;
                          AllowAllUp:=true;
                          Visible:=true;
                          SetBounds(Ordenata[i].Left+70,Ordenata[i].Top,15,15);
                          Caption:='';
                          Parent:=self;
                          tag:=i;
                          imlvara.GetBitmap(0,Glyph);
                          NumGlyphs:=4;
                          Cursor:=crarrow;
                          Transparent:=true;
                          OnClick:=@spdarratonclick;
                          Enabled:=false;
                          visible:=false;
                      end;
            end;
          for i:= 0 to g_num_ord_pantalla-1 do
            begin
                  imgFoto[i]:= TImage.Create(self);
                  with imgFoto[i] do
                      begin
                          Visible:=true;
                          SetBounds(Ordenata[i].Left+68,Ordenata[i].Top+46,16,16);
                          stretch:=true;
                          Cursor:=crArrow;
                          imlmenu.GetBitmap(50,Picture.Bitmap);
                          Parent:=self;
                          tag:=i;
                          visible:=false;
                          OnMouseEnter:=@imgFotoOnMouseEnter;
                          OnMouseLeave:=@imgFotoOnMouseLeave;
                    end;
            end;
        for i:=g_num_ord_pantalla-1 downto 0 do
            begin
                imgFotos[i]:= TImage.Create(self);
                with imgFotos[i] do
                    begin
                        SetBounds(Ordenata[i].Left,Ordenata[i].Top-15,66,76);
                        stretch:=true;
                        Cursor:=crarrow;
                        imlFoto.GetBitmap(0,Picture.Bitmap);
                        Parent:=self;
                        tag:=i;
                        visible:=false;
                        OnClick:=@OrdenataClick;
                        Cursor:=crHandPoint;
                          ShowHint:=true;
                          Hint:='Apagar equipo';
                        if i< g_num_ord_aula then
                        if equipoalumno[i].EstadoActivadEquipo=eAveriado then
                            enabled:=false;
                    end;
            end;
        for i:= 0 to g_num_ord_pantalla-1 do
            begin
                  spGrupos[i]:= TspeedButton.Create(self);
                  with spGrupos[i] do
                      begin
                          icogrupo:=i mod 3;
                          icogrupo:=icogrupo+41;
                          GroupIndex:=102;
                          Down:=false;
                          AllowAllUp:=true;
                          Visible:=true;
                          SetBounds(868,565-(i*22),20,20);
                          Caption:='';
                          ShowHint:=true;
                          cursor:=crHandPoint;
                          Parent:=self;
                          tag:=i;
                          imlmenu.GetBitmap(icogrupo,Glyph);
                          NumGlyphs:=1;
                          Cursor:=crarrow;
                          Transparent:=true;
                          OnClick:=@spgruposclick;
                          Enabled:=true;
                          visible:=false;
                      end;
            end;
          for i:=g_num_ord_pantalla-1 downto 0 do
              begin
                  lblOrdenata[i]:= Tlabel.Create(self);
                  with lblOrdenata[i] do
                      begin
                          autosize:=false;
                          SetBounds(Ordenata[i].Left-22,Ordenata[i].top+Ordenata[i].height,Ordenata[i].Width+45,15);
                          alignment:=tacenter;
                          font.name:='Sans';
                          font.size:=8;
                          Font.Color:=rgb(100,100,100);
                          caption:= 'Mesa ' + inttostr(i+1);
                          Parent:=self;
                          font.Style:=[fsbold];
                          layout:=tlcenter;
                          Transparent:=true;
                          visible:=true;
                      end;
              end;
          for i:=g_num_ord_pantalla-1 downto 0 do
              begin
                  lblmesa[i]:= Tlabel.Create(self);
                  with lblmesa[i] do
                      begin
                          autosize:=false;
                          SetBounds(Ordenata[i].Left-19,Ordenata[i].top,16,14);
                          alignment:=taRightJustify;
                          Font.Name:='Sans';
                          Font.Size :=10;
                          Font.Color:=rgb(100,100,100);
                          Font.Color:=clsilver;
                          caption:=inttostr(i+1);
                          Parent:=self;
                          font.Style:=[fsbold];
                          layout:=tlcenter;
                          Transparent:=true;
                          visible:=false;
                      end;
              end;
          for i:=g_num_ord_aula to g_num_ord_pantalla-1 do
              lblOrdenata[i].Caption:='';
          for i:=g_num_ord_aula to g_num_ord_pantalla-1 do
              lblmesa[i].visible:=false;
          for i:=g_num_ord_aula to g_num_ord_pantalla-1 do
              imgFoto[i].visible:=false;
          for i:=g_num_ord_aula to g_num_ord_pantalla-1 do
              imgFotos[i].visible:=false;
          for i:=low(rbApl) to high(rbApl) do
              begin
                  rbApl[i]:= TRadioButton.Create(self);
                  with rbapl[i] do
                      begin
                          setbounds(110,140 + i*34,152,26);
                          Color:=rgb(245,245,245);
                          Cursor:=crHandPoint;
                          Font.name:='Sans';
                          Font.Size:=12;
                          Parent:=pnlan;
                          tag:=i;
                          Caption:=g_NombreAplicacion[i+1];
                          OnClick:=@rbAplClicK;
                          visible:=true;
                      end;
              end;
          lbloficina.Top:= rbApl[0].top-20;
          lblgraficos.Top:= rbApl[2].top-20;
          lblotros.Top:= rbApl[5].top-20;
      end;
procedure TfrmMain.imgFotoOnMouseEnter(Sender: TObject);
    var
        dirFoto:string;
        nOelegido:integer;
    begin
        if pnFotos.visible=false  then
            begin
                nOelegido:=(sender as Timage).tag;
                if  (Trim(equipoAlumno[nOelegido].UsuarioActivo)<>'') then
                    begin
                    dirFoto:='/home/instituto/.fotos/'+equipoAlumno[nOelegido].UsuarioActivo+'.jpg';
                    if FileExists(dirFoto)then
                        begin
                            CargaImagenFoto(dirFoto);
                        end
                    else
                        begin
                           imlFoto.GetBitmap(0,imgFotoAlumno.Picture.Bitmap);
                        end;
                    pnFotos.Left:=Ordenata[nOelegido].left;
                    pnFotos.top:=Ordenata[nOelegido].top-15;
                    pnFotos.visible:=true;
                    pnFotos.BringToFront;
                end;
           end
    end;
procedure TfrmMain.cargarImagenGeneral(numequipo:integer);
    var
          dirFoto:String;
    begin
        if  (Trim(equipoAlumno[numequipo].UsuarioActivo)<>'') then
            begin
            dirFoto:='/home/instituto/.fotos/'+equipoAlumno[numequipo].UsuarioActivo+'.jpg';
            if FileExists(dirFoto)then
                begin
                    if equipoAlumno[numequipo].UsuarioActivo  <> equipoAlumno[numequipo].FotoAlumno  then
                    begin
                       CargaImagenFotos(numequipo,dirFoto);
                       equipoAlumno[numequipo].FotoAlumno:=equipoAlumno[numequipo].UsuarioActivo
                    end
                end
            else
                begin
                   imlFoto.GetBitmap(0,imgFotos[numequipo].Picture.Bitmap);
                end;
        end;

    end;

procedure TfrmMain.CargaImagenFotos(i:integer;sArc:String);
    var
        jpg:TJPEGImage;
    begin
        jpg:=TJPEGImage.create;
        try
            jpg.loadfromfile(sArc);
            imgFotos[i].Picture.Bitmap.Assign(jpg);
        finally
            jpg.Free;
        end;
    end;
procedure TfrmMain.CargaImagenFoto(sArc:String);
    var
        jpg:TJPEGImage;
    begin
        jpg:=TJPEGImage.create;
        try
            jpg.loadfromfile(sArc);
            imgFotoAlumno.Picture.Bitmap.Assign(jpg);
        finally
            jpg.Free;
        end;
    end;
procedure TfrmMain.imgFotoOnMouseLeave(Sender: TObject);
  begin
      if pnFotos.visible then pnFotos.visible:=False;
  end;
procedure TfrmMain.IniciarRelojes();
     var
         i:integer;
     begin
         for i:= 0 to high(equipoAlumno) do
         begin
             Application.ProcessMessages;
             equipoAlumno[i].IniciarRelojes();
             Application.ProcessMessages;

         end

     end;
 procedure TfrmMain.spgruposclick(sender:Tobject);
    begin
        ComenzarUnGrupo((sender as TSpeedButton).tag,f_miaula);
    end;

 procedure TfrmMain.EjecutarOrdenesFin(tipo:integer;estado:boolean;EnviarMensaje:boolean=false;asunto:string='Aviso';texto:string='Mensaje del profesor');
    var
        i,inicio,fin:integer;
    begin
        ObtenerInicioFin(tipo,inicio,fin);
        for  i:=inicio to fin do
            begin
                if ((f_pantallaactiva<>0) and(equipoalumno[i].IconoEquipo(0) <> 1)) or (not ordenata[i].Enabled) or  (equipoalumno[i].EstadoActivadEquipo=eAveriado) then continue;
                equipoAlumno[i].ElegirOrden(f_pantallaactiva,estado);
                application.ProcessMessages;
                if f_PantallaActiva= 0 then
                    begin
                        if Not estado then
                            begin
                              lblOrdenata[i].Caption:='Mesa '+NumOrdLet(i);
                              equipoAlumno[i].UsuarioActivo:='';
                              imgFoto[i].visible:=false;
                              imgFotos[i].visible:=false;
                            end
                        else
                            begin
                                sleep(g_tiempo_arranque);
                            end;
                        fcontadorbarra[i]:=0;
                        PintarMonPant0(i);
                        application.ProcessMessages
                    end
                else
                    begin
                        if estado then
                            CambiarIconoActivo(i)
                        else
                            CambiarIconoInactivo(i);
                        application.ProcessMessages;
                        if EnviarMensaje then
                            MensajeEnviado(i,asunto,texto);
                        Application.ProcessMessages;
                        if f_pantallaActiva=2 then
                            CambiarEstadoBotonRaton(i,estado);
                    end;
                application.ProcessMessages;
                sleep(100);
                application.ProcessMessages;
            end
    end;

procedure TfrmMain.CambiarEstadoBotonRaton(i:integer;est:Boolean);
    begin
        if not est then
            begin
                if spdarraton[i].enabled then
                    begin
                        spdarraton[i].enabled:=false;
                        spdarraton[i].Cursor:=crarrow;
                        equipoAlumno[i].poseoRaton:=true;
                    end;
                if spdarraton[i].down then spdarraton[i].down:=false;
            end
        else
            begin
                if not spdarraton[i].enabled then
                    begin
                        spdarraton[i].enabled:=true;
                        spdarraton[i].Cursor:=crhandPoint;
                        equipoAlumno[i].poseoRaton:=false;
                    end;
                if spdarraton[i].down then spdarraton[i].down:=false;
            end;
    end;

procedure TfrmMain.MensajeEnviado(ord_num:integer; asunto,texto:string);
    begin
          if f_PantallaActiva in [1,2,10,12,13] then
            begin
                g_mensaje_prioridad:='0';
                g_mensaje_asunto:=TIdURI.ParamsEncode(asunto);
                g_mensaje_texto:=TIdURI.ParamsEncode(texto);
                equipoAlumno[ord_num].mensaje();
            end;
    end;

Procedure TfrmMain.CambiarIconoActivo(ord_num:integer);
    var
        activo:boolean;
    begin
        activo:=ordenata[ord_num].enabled;
        if activo then
            begin
                ordenata[ord_num].Picture.Bitmap.clear;
                imlIcoAct1.GetBitmap(f_PantallaActiva,ordenata[ord_num].Picture.Bitmap);
            end
    end;
procedure TfrmMain.CambiarIconoInactivo(ord_num:integer);
    var
        activo:boolean;
    begin
        activo:=ordenata[ord_num].enabled;
        if activo then
            begin
                ordenata[ord_num].Picture.Bitmap.clear;
                imlicoina.GetBitmap(f_PantallaActiva,ordenata[ord_num].Picture.Bitmap);
            end
    end;

procedure TfrmMain.ObtenerInicioFin(ord_num:integer;var inicio:integer; var fin:integer);
    begin
        if (ord_num=-1) then
            inicio:=0
        else
            inicio:=ord_num;
        if (ord_num=-1) then
            fin:=g_num_ord_aula-1
        else
            fin:=ord_num;
    end;

Procedure TfrmMain.OrdenataClick(sender:TObject);
    var
        ordpul:integer;
    begin
        if validarcontenido(f_PantallaActiva)=false then exit;
        ordpul:=(sender as Timage).Tag;
        if equipoalumno[ordpul].fIconoMonitor[f_PantallaActiva]=0 then
            begin
                equipoalumno[ordpul].fIconoMonitor[f_PantallaActiva]:=1;
                Iniciaractividad(f_PantallaActiva,ordpul);
            end
        else if equipoalumno[ordpul].fIconoMonitor[f_PantallaActiva]=1 then
            begin
                equipoalumno[ordpul].fIconoMonitor[f_PantallaActiva]:=0;
                DetenerActividad(f_PantallaActiva,ordpul);
            end;
    end;
Procedure TfrmMain.IniciarActividad(numero_pantalla:integer;ord_num:integer);
    begin
        case numero_pantalla of
            0:AlumnoEncender(ord_num);
            1:AlumnoVer(ord_num);
            2:AlumnoMostrar(ord_num);
            3:AlumnoMensaje(ord_num);
            4:AlumnoArchivo(ord_num);
            5:AlumnoRecibir(ord_num);
            6:AlumnoAplicacion(ord_num,f_NumeroAplicacion);
            7:AlumnoNavegar(ord_num);
            8:AlumnoDevolver(ord_num);
            9:AlumnoCarpeta(ord_num);
            10:AlumnoVlc(ord_num);
            11:AlumnoPresentacion(ord_num);
            12:AlumnoInternetNo(ord_num);
            13:AlumnoTecladoRatonNo(ord_num);
        end;
    end;

Procedure TfrmMain.DetenerActividad(numero_pantalla:integer;ord_num:integer);
    begin
        case numero_pantalla of
            0:AlumnoEncenderNo(ord_num);
            1:AlumnoVerNo(ord_num);
            2:AlumnoMostrarNo(ord_num);
            3:AlumnoMensajeNo(ord_num);
            4:AlumnoArchivoNo(ord_num);
            5:AlumnoRecibirno(ord_num);
            6:AlumnoAplicacionNo(ord_num);
            7:AlumnoNavegarNo(ord_num);
            8:AlumnoDevolverNo(ord_num);
            9:AlumnoCarpetaNo(ord_num);
            10:AlumnoVlcNo(ord_num);
            11:AlumnoPresentacionNo(ord_num);
            12:AlumnoInternetSi(ord_num);
            13:AlumnoTecladoRatonSi(ord_num);
        end;
    end;

procedure TfrmMain.despulsarMonitores(numero_pant:integer);
    var
        i:integer;
    begin
        for i:=0 to high(equipoalumno) do
            begin
                if  equipoalumno[i].EstadoActivadEquipo<>eAveriado then
                    equipoalumno[i].fMonitorPulsado[numero_pant]:=false;
            end;
    end;

procedure TfrmMain.pulsarMonitores(numero_pant:integer);
    var
        i:integer;
    begin
        for i:=0 to high(equipoalumno) do
            begin
                if  equipoalumno[i].EstadoActivadEquipo<>eAveriado  then
                    equipoalumno[i].fMonitorPulsado[numero_pant]:=true;
            end;
    end;

procedure TfrmMain.OrdenRestablecerTodos(numero_pantalla:integer);
    begin
        cursor:=crHourGlass;
        Enabled:=false;
        try
            pulsarMonitores(numero_pantalla);
            case numero_pantalla of
                0:AlumnoEncenderNo(-1);
                1:AlumnoVerNo(-1);
                2:begin
                        g_mostrandopantalla:=0;
                        AlumnoMostrarNo(-1);
                  end;
                3:AlumnoMensajeNo(-1);
                4:AlumnoArchivoNo(-1);
                5:AlumnoRecibirNo(-1);
                6:AlumnoAplicacionNo(-1);
                7:AlumnoNavegarNo(-1);
                8:AlumnoDevolverNo(-1);
                9:AlumnoCarpetaNo(-1);
                10:AlumnoVlcNo(-1);
                12:AlumnoInternetSi(-1);
                13:AlumnoTecladoRatonSi(-1);
            end;
        finally
            begin
                Enabled:=true;
                cursor:=crarrow;
            end;
        end;
    end;

procedure TfrmMain.OrdenEjecutarTodos(numero_pantalla:integer);
    begin
        cursor:=crHourGlass;
        enabled:=false;
        try
            despulsarMonitores(numero_pantalla);
            case numero_pantalla of
               0:AlumnoEncender(-1);
               1:AlumnoVer(-1);
               2:
                   begin
                       g_mostrandopantalla:=1;
                       AlumnoMostrar(-1);
                   end;
               3:AlumnoMensaje(-1);
               4:AlumnoArchivo(-1);
               5:AlumnoRecibir(-1);
               6:AlumnoAplicacion(-1,f_NumeroAplicacion);
               7:AlumnoNavegar(-1);
               8:AlumnoDevolver(-1);
               9:AlumnoCarpeta(-1);
               10:AlumnoVlc(-1);
               11:mensaje(MEN_PRESENTACION_ALUMNO,aceptar);
               12:AlumnoInternetNo(-1);
               13:AlumnoTecladoRatonNo(-1);
            end;
        finally
            begin
                Enabled:=true;
                cursor:=crArrow;
            end;
       end
    end;

Function TfrmMain.ValidarContenido(PantallaActual:integer):boolean;
    begin
         result:=true;
         case PantallaActual of
            1:
                begin
                    if chkver.checked=false then
                        result:=true
                    else
                        begin
                            if ((length(trim(mever.Text))<1) or (length(trim(edasuver.Text))<1)) then
                            begin
                                mensaje(MEN_ESCRIBE_MENSAJE,aceptar);
                                result:=false;
                            end;
                        end;
                end;
            2:
                begin
                    if chkmostrar.checked=false then
                        result:=true
                    else
                        begin
                              if ((length(trim(memostrar.Text))<1) or (length(trim(edmostrar.Text))<1)) then
                                  begin
                                      mensaje(MEN_ESCRIBE_MENSAJE,aceptar);
                                      result:=false;
                                  end;
                        end;

                end;
            3:
               begin
                    if ((length(trim(metexmen.Text))<1) or (length(trim(edasumen.Text))<1)) then
                        begin
                            mensaje(MEN_ESCRIBE_MENSAJE,aceptar);
                            result:=false;
                        end;
                end;
            4:
                begin
                    if rightstr(fnArchivo.FileName,2)='/*' then
                        begin
                            mensaje(MEN_ERROR_COPIA_CARPETA,aceptar);
                              result:=true;
                              exit;
                        end;
                    if not fileexists(fnArchivo.FileName) then
                    begin
                            mensaje(MEN_NO_EXISTE_ARCHIVO,aceptar);
                            result:=false;
                            exit;
                    end;
                    if length(trim(meTexArc.Text))<1  then
                        begin
                             mensaje(MEN_ESCRIBE_MENSAJE,aceptar);
                             result:=false;
                        end;
                 end;
             5:
                 begin
                    if ((length(trim(metexrec.Text))<1) or (length(trim(edasurec.Text))<1)) then
                        begin
                            mensaje(MEN_ESCRIBE_MENSAJE,aceptar);
                            result:=false;
                        end
                    else if cboAsirec.ItemIndex=-1 then
                        begin
                            mensaje(MEN_ELIGE_ASIGNATURA,aceptar);
                            result:=false;
                        end
                    else if cborec.ItemIndex=-1 then
                        begin
                            mensaje(MEN_ELIGE_CURSO,aceptar);
                            result:=false;
                        end;
                end;
            8:
                begin
                    if ((length(trim(mearcdev.Text))<1) or (length(trim(edasudev.Text))<1)) then
                        begin
                            mensaje(MEN_ESCRIBE_MENSAJE,aceptar);
                            result:=false;
                        end
                    else if cboAsidev.ItemIndex=-1 then
                        begin
                            mensaje(MEN_ELIGE_ASIGNATURA,aceptar);
                            result:=false;
                        end
                    else if cbocurdev.ItemIndex=-1 then
                        begin
                            mensaje(MEN_ELIGE_CURSO,aceptar);
                            result:=false;
                        end;
                end;
            9:
                begin
                    if ((length(trim(mecarpertas.Text))<1)) then
                        begin
                            mensaje(MEN_ESCRIBE_MENSAJE,aceptar);
                            result:=false;
                        end
                    else if (length(decarpetas.directory)< 2) or (not directoryexists(decarpetas.directory)) then
                        begin
                            mensaje(MEN_ELIGE_DIRECTORIO,aceptar);
                            result:=false;
                        end
                end;
            10:
                begin
                    if ((length(trim(ednomvlc.Text))<4)) then
                        begin
                            mensaje(MEN_ELIGE_VIDEO,aceptar);
                            result:=false;
                        end
                    else if btniniciar.Enabled=true then
                        begin
                            mensaje(MEN_INICIAR_VIDEO,aceptar);
                            result:=false;
                        end
                end;
        end;
    end;

 Procedure TfrmMain.MostrarOrdenadores();
    const
        tor:integer=505;
        wo:integer=66;ho:integer=61;
    var
       lor,sepl,lb,tb,spt,i,numsep,numfilas:integer;
       posi3,posi2,cambioi:integer;
    begin
        if g_numero_columnas=3 then
            sepl:=150
        else
            sepl:=260;
        if g_TipoClase=1 then
            begin
                cambioi:=1;
                posi3:=480;
                posi2:=500;
            end
        else
            begin
                cambioi:=-1;
                posi3:=780;
                posi2:=760;
            end;
        if g_numero_columnas=3 then
            lor:=posi3
        else
            lor:=posi2;
        numfilas:=(g_num_ord_pantalla div g_numero_columnas);
        numsep:=numfilas -1;
        spt:=(510-(numfilas*63)) div numsep;
        for i:=g_num_ord_pantalla-1 downto 0  do
            begin
                tb:= i div g_numero_columnas;tb:= tor-tb*(63+spt);
                lb:= i mod g_numero_columnas;lb:= lor+cambioi*lb*sepl;
                Ordenata[i].SetBounds(lb,tb,wo,ho);
                Ordenata[i].visible:=true;
                pgOrdenata[i].Width:=Ordenata[i].Width-12;
                pgOrdenata[i].Height:=8;
                pgOrdenata[i].left:=Ordenata[i].left+6;
                pgOrdenata[i].top:=Ordenata[i].top+40;
                pgOrdenata[i].visible:=false;
            end;
        for i:=g_num_ord_aula to g_num_ord_pantalla-1  do
        begin
            Ordenata[i].visible:=false;
            pgOrdenata[i].visible:=false;
        end
    end;
Procedure TfrmMain.MostrarPersonal();
    var
        alto,ancho,i:integer;
    begin
        if High(ordenata)>18 then
            begin
               alto:=58;ancho:=63
            end
        else
            begin
               alto:=61;ancho:=66;
            end;
        for i:=0 to high(ordenata) do
        begin
            Ordenata[i].visible:=false;
            pgOrdenata[i].visible:=false;
        end;
        for i:=0 to g_num_ord_aula-1 do
            begin
                Ordenata[i].SetBounds(equipoalumno[i].L,equipoalumno[i].T,ancho,alto);
                Ordenata[i].Visible:=true;
                pgOrdenata[i].Width:=ancho-12;
                pgOrdenata[i].Height:=8;
                pgOrdenata[i].left:=Ordenata[i].left+6;
                pgOrdenata[i].top:=Ordenata[i].top+40;
                pgOrdenata[i].visible:=false;
            end;
    end;

procedure TfrmMain.spdarratonclick(sender:Tobject);
    var
        nor:integer;
    begin
        nor:=(sender as Tspeedbutton).tag;
        if equipoAlumno[nor].poseoraton=false then
            begin
               AlumnoRatonSi(nor)
            end
        else
            begin
              AlumnoRatonNo(nor)
            end
    end;

procedure TfrmMain.CargarConfiguracionUsuario();
    begin
        if not fileexists(equipoProfesor.ArcSetupProfe) then
            begin
                TfrmProgramas.Create(nil).ShowModal;
                frmProgramas.free;
            end;
        if fileexists(equipoProfesor.ArcSetupProfe) then
            LeerSetupProfe();
    end;

function TfrmMain.NumeroOrdenadorePantalla(numero_ordenadores:integer):integer;
    begin
        result:=12;
        if g_DisenoClase=1 then g_numero_columnas:=3;
        case g_numero_columnas of
            3:
                begin
                    Case numero_ordenadores of
                        0..6:g_sepT:=350;
                        7..9:g_sepT:=148;
                        10..12:g_sepT:=75;
                        13..15:g_sepT:=44;
                        16..18:g_sepT:=25;
                        19..21:g_sepT:=1;
                    end;
                    if numero_ordenadores<=6 then
                    result:=6
                    else
                    result:=(((numero_ordenadores-1) div 3+1 )*3);
                end;
            2:
                begin
                    Case numero_ordenadores of
                        0..4:g_sepT:=359;
                        5,6:g_sepT:=148;
                        7,8:g_sepT:=75;
                        9,10:g_sepT:=44;
                        11,12:g_sepT:=25;
                        13..14:g_sepT:=1;
                    end;
                    if numero_ordenadores<=4 then
                    result:=4
                    else
                    result:=(((numero_ordenadores-1) div 2+1 )*2);
                end;
        end;
    end;
procedure TfrmMain.CargarConfiguracionAula(archivoaula:string);
    var
        Mifichero:TMemIniFile;
        i:integer;
        numfilas:string;
        nmord:string;
        mhost,mip,mmac:string;
        mestado:boolean;
    begin
        try
            if FileExists(archivoaula) then
                begin
                    Mifichero:= TMemIniFile.create(archivoaula);
                    With Mifichero do
                        begin
                            g_host_alumno:= ReadString('Profesor','mesa alumno','');
                            nmord:=ReadString('Aula','Numero Ordenadores','12');
                            if Trim(nmord)='' then
                                g_num_ord_aula:=12
                            else
                                g_num_ord_aula:=strtoint(nmord);
                            g_ipvlc:=ReadString('Vlc','IP','239.255.255.0');
                            numfilas:=ReadString('Aula','Numero Filas','3');
                            if (length(trim(numfilas))<1) then
                                g_numero_columnas:=3
                            else
                                g_numero_columnas:=strtoint(numfilas);
                            g_servidor:=ReadString('Servidor','IP','');                            g_TipoClase:= ReadInteger('TipoClase','Tipo',0);
                            g_Internet_defecto:=Readbool('Internet','Internet desactivado',false);
                            g_RatonTecladoDefecto:=Readbool('RatonTeclado','RatonTeclado inactivos',false);
                            equipoProfesor.AccesoInternetInactivo:=g_Internet_defecto;
                            equipoProfesor.RatonTecladosInactivos:=g_RatonTecladoDefecto;
                            g_CanonActivo:=(Readbool('Canon','Activo',false));
                            g_CanonTiempo:=ReadInteger('Canon','Tiempo',4);
                            g_tiempo_arranque:=ReadInteger('Aula','TiempoArranque',200);
                            if g_CanonTiempo>15 then g_CanonTiempo:=4;
                            g_num_ord_pantalla:=NumeroOrdenadorePantalla(g_num_ord_aula);
                            g_DisenoClase:=ReadInteger('Diseno','Tipo',0);
                            setlength(equipoAlumno,g_num_ord_aula);
                            for i:=0 to g_num_ord_pantalla-1 do
                                begin
                                    if  i < g_num_ord_aula  then
                                        begin
                                            mestado :=strtobool(ReadString('Estado','Mesa '+ NumOrdLet(i),'-1'));
                                            mhost:=ReadString('Mesas','Mesa '+ NumOrdLet(i),'');
                                            if mhost='' then mhost:=HallaHost(i);
                                            mip:=ReadString('IPS','Mesa '+ NumOrdLet(i),'');
                                            mmac:=ReadString('MAC','Mesa '+ NumOrdLet(i),'');
                                            equipoAlumno[i]:=TEquipo.create(i,mhost,mip,mmac,mestado);
                                            if g_DisenoClase>0 then
                                                begin
                                                      LeerCoordenadas(g_myl,g_myt,(ReadString('Diseno','Mesa '+ NumOrdLet(i),'0,0')));
                                                      equipoAlumno[i].L:=g_myl;
                                                      equipoAlumno[i].T:=g_myt;
                                                end;
                                            Application.ProcessMessages;
                                            if g_RatonTecladoDefecto then
                                               equipoAlumno[i].ElegirOrden(13,true);
                                            if  g_Internet_defecto then
                                               equipoAlumno[i].ElegirOrden(12,true);
                                            sleep(100);
                                        end
                                end;
                            equipoProfesor.host:= ReadString('Profesor','mesa profesor','');
                            Free;
                        end;
                  end;
        except
            begin
                Mensaje(MEN_ERROR_AULA,aceptar);
                application.Terminate
            end
        end;
    end;

function TfrmMain.HallaHost(numord:integer):string;
    const
        ORD_AULA:string='hostname | cut -f1 -d"." |cut -f1 -d"-"|cut -f1 -d"_"';
    var
        miaula:string;
        numero:string;
    begin
         miaula:=HallarDato(ORD_AULA);
         if numord<9 then
             numero:='0'+inttostr(numord+1)
         else
             numero:= inttostr(numord+1);
         result:=miaula+'-o'+numero
    end;

procedure TfrmMain.CargarDatosAula();
    const
        SAlUMNO:string='hostname | cut -f1 -d"-"';
     begin
        g_host_alumno:=HallarDato(SAlUMNO);
        g_host_alumno:=g_host_alumno+'-o';
     end;

procedure TfrmMain.imgPanelCanonMouseEnter(Sender: TObject);
    begin
        if (sender as Timage).enabled=false then exit;
        (sender as Timage).Picture.bitmap.Clear;
        imlcanon.getBitmap(1,(sender as Timage).picture.Bitmap);
    end;

procedure TfrmMain.imgPanelCanonMouseLeave(Sender: TObject);
    begin
        if (sender as Timage).enabled=false then exit;
        (sender as Timage).Picture.bitmap.Clear;
        imlcanon.getBitmap(0,(sender as Timage).picture.Bitmap);
    end;

procedure TfrmMain.ImgPresentaClic();
   begin
        CerrarServidorVnc();
        MostrarMenus();
        mnuEncenderclick(mnuEncender);
        application.ProcessMessages;
        pnPresenta.Visible:=false;
        cursor:=crDefault;
        application.ProcessMessages;
        timer2.Enabled:=false;
    end;
procedure TfrmMain.lblExamenClick(Sender: TObject);
    begin
        if g_examinando then
            begin
                frmExamen.show;
                hide;
            end;
        if g_contadorExamen<=0 then
            ExamenFinalizado;
    end;

procedure TfrmMain.lstPagClick(Sender: TObject);
    begin
        if lstpag.ItemIndex <>-1 then
             edpagina.Text:=lstpag.Items.Strings[lstpag.itemindex];
    end;

procedure TfrmMain.lstPagDblClick(Sender: TObject);
    begin
        if lstpag.ItemIndex >-1 then
            Ejecutar(g_ComandoAplicacion[0]+' '+lstpag.items[lstpag.ItemIndex]+' &')
    end;

procedure TfrmMain.mnuAcercadeClick(Sender: TObject);
    begin
        Application.CreateForm(TfrmAcerca, frmAcerca);
        frmAcerca.ShowModal;
    end;

procedure TfrmMain.mnuAnadirClick(Sender: TObject);
    begin
        application.processMessages;
        application.createForm(TfrmNombresAlumnos,frmNombresAlumnos);
        frmNombresAlumnos.showmodal;
    end;

procedure TfrmMain.mnuApagarServidorClick(Sender: TObject);
    begin
        CerrarServidorVnc();
        mnuIniciarServidor.Checked:=false;
        mnuApagarServidor.Checked:=true;
    end;

procedure TfrmMain.mnuApagarClick(Sender: TObject);
    begin
        if mensaje(MEN_PROFE_APAGAR,sino)=1 then
            begin
                application.ProcessMessages;
                if Mensaje(MEN_ALUMNOS_APAGAR,sino)=1 then
                    AlumnoEncenderNo(-1);
                application.ProcessMessages;
                sleep(1000);
                equipoprofesor.apagarProfesor();
            end;
    end;

procedure TfrmMain.mnuApagaSalvaClick(Sender: TObject);
    begin
        if TodosApagados(true) then exit;
        application.ProcessMessages;
        ApagarSalvaPantallas();
    end;

procedure TfrmMain.mnuArcEnvClick(Sender: TObject);
    begin
        if mensaje(MEN_ELIMINAR_ENVIADOS,sino)=1 then
            AlumnoLimpiarRecibidos;
    end;

procedure TfrmMain.mnuArcRecClick(Sender: TObject);
    begin
        if mensaje(MEN_ELIMINAR_RECIBIDOS,sino)=1 then
            AlumnoLimpiarenviar ;
    end;

procedure TfrmMain.mnuCamaraClick(Sender: TObject);
    begin

        Application.ProcessMessages;
        f_camara:=true;
        if TodosApagados then  exit;
        iniciarvnc(-1);

        Application.ProcessMessages;
        f_camara:=false;
        self.hide;
        TfrmCamara1.create(self).showmodal;
        self.show;

    end;

procedure TfrmMain.mnuCDClick(Sender: TObject);
    //const
        //P_SONIDO:string='xmms';
    begin
        //ordenesaula(ORD_EJECUTAR_EN_PROFE,[P_SONIDO])
    end;

procedure TfrmMain.AlumnoLimpiarEnviar();
    var
        i:integer;
    begin
        g_tipo_limpieza_archivos:='1';
        for i:=0 to high(equipoalumno) do
                equipoalumno[i].limpiarArchivos();
    end;

procedure TfrmMain.AlumnoLimpiarRecibidos();
    var
        i:integer;
    begin
        g_tipo_limpieza_archivos:='0';
        for i:=0 to high(equipoalumno) do
                equipoalumno[i].limpiarArchivos();
    end;
Procedure TfrmMain.ApagarSalvaPantallas();
    var
        i:integer;
    begin
        for  i:= 0 to high(equipoalumno) do
             equipoalumno[i].apagaSalva();
    end;

procedure TfrmMain.mnuConfProfeClick(Sender: TObject);
    begin
        application.ProcessMessages;
        TfrmProgramas.Create(nil).showmodal;
        RecargarAplicaciones;
    end;

procedure TfrmMain.mnuDesactivarClick(Sender: TObject);
    begin
        f_PantallaActiva:=12;
        menusclick(mnudesactivar,f_PantallaActiva,pndes,spint);
        application.ProcessMessages;
    end;

procedure TfrmMain.mnuDesactivarTRClick(Sender: TObject);
    begin
        f_PantallaActiva:=13;
        menusclick(mnudesactivarTR,f_PantallaActiva,pnTec,spBlo);
        application.ProcessMessages;
    end;

procedure TfrmMain.mnuDesconectarClientesClick(Sender: TObject);
    var
        i:integer;
    begin
        application.ProcessMessages;
        for i:=0 to g_num_ord_aula-1 do
            equipoAlumno[i].verNo();
        mnuIniciarClientes.Checked:=false;
        mnuDesconectarclientes.Checked:=true;
    end;

procedure TfrmMain.mnuDevTodClick(Sender: TObject);
    begin
        f_PantallaActiva:=8;
        MenusClick(mnudevtod,f_PantallaActiva,pndev,spdev);
        RefrescarRecogidos(cboAsiDev,'');
    end;

procedure TfrmMain.mnuEncenderClick(Sender: TObject);
    begin
        f_PantallaActiva:=0;
        menusclick(mnuencender,f_PantallaActiva,pnenc,spenc);
        pnenc.BringToFront;
    end;

procedure TfrmMain.mnuEnvCarClick(Sender: TObject);
    begin
        f_PantallaActiva:=9;
        MenusClick(mnuenvcar,f_PantallaActiva,pncar,spcar);
    end;

procedure TfrmMain.mnuEnviarArchivoClick(Sender: TObject);
    begin
         f_PantallaActiva:=4;
         menusclick(mnuEnviarArchivo,f_PantallaActiva,pnarc,sparc);
    end;

procedure TfrmMain.mnuEnvRecClick(Sender: TObject);
    begin
        if mensaje(MEN_ELIMINAR_ENVREC,sino)=1 then
            begin
                AlumnoLimpiarRecibidosEnviados
            end
    end;

procedure TfrmMain.AlumnoLimpiarRecibidosEnviados();
    var
        i:integer;
    begin
        g_tipo_limpieza_archivos:='2';
        for i:=0 to high(equipoalumno) do
                equipoalumno[i].limpiarArchivos();
    end;
procedure TfrmMain.mnuIniciarClientesClick(Sender: TObject);
    begin
        iniciarvnc(-1);
        mnuIniciarClientes.Checked:=true;
        mnuDesconectarclientes.Checked:=false;
    end;
 procedure TfrmMain.iniciarvnc(tipo:integer);
    var
        inicio,fin,i:integer;
    begin
        inicio:=0;
        fin:=0;
        obteneriniciofin(tipo,inicio,fin);
        for i:=inicio to fin do
        begin
            equipoAlumno[i].iniciarClientesVNC();
            Application.ProcessMessages;
        end;

    end;

procedure TfrmMain.mnuIniciarServidorClick(Sender: TObject);
    begin
        IniciarServidorVnc;
    end;

procedure TfrmMain.mnuIniEvaClick(Sender: TObject);
    begin
        mnuRefrescarClick(mnuRefrescar);
        Application.CreateForm(TfrmEvaluar, frmEvaluar);
        frmEvaluar.ShowModal;
    end;

procedure TfrmMain.mnuCanonEncenderClick(Sender: TObject);
    begin
        Application.CreateForm(TfrmCanon, frmCanon);
        frmCanon.ShowModal;
    end;

procedure TfrmMain.IniciarCanon();
    var i: integer;
        usuariocanon:string;
    begin
         for i:=0 to g_num_ord_aula-1 do
             begin
                  if equipoAlumno[i].EstadoActivadEquipo in [eEncendido,eUsuario] then
                  begin
                    usuariocanon:= g_host_alumno+ NumOrdLet(i);
                    equipoAlumno[i].canon(usuariocanon);
                    Application.ProcessMessages;
                    sleep(10000);
                  end;
             end
    end;

procedure TfrmMain.munCerrarCanonClick(Sender: TObject);
    begin
        if mensaje('Esto cerrará todas las sesiones iniciadas en los equipos encendidos. ¿Desea continuar?', sino)=1 then
          begin
               TerminarCanon();
          end;
    end;

procedure TfrmMain.TerminarCanon();
    const
        tempcur:string= 'xmodmap -pke > /tmp/.sermodaula';
    var
        i: integer;
        cerrarProcesos:string;
    begin
        Ejecutar(tempcur);
        for i:=0 to g_num_ord_aula-1 do
            begin
                if equipoAlumno[i].EstadoActivadEquipo in [eUsuario,eEncendido] then
                    begin
                        equipoAlumno[i].BloquearNo();
                        Application.ProcessMessages;
                    end;
            end;
        Application.ProcessMessages;
        sleep(5000);
        for i:=0 to g_num_ord_aula-1 do
            begin
                if equipoAlumno[i].EstadoActivadEquipo in [eUsuario] then
                    begin
                        equipoAlumno[i].cierraUsuario();
                        Application.ProcessMessages;
                    end;
            end;
        for i:=0 to g_num_ord_aula-1 do
            begin
                if equipoAlumno[i].EstadoActivadEquipo in [eUsuario, eEncendido] then
                    begin
                        Application.ProcessMessages;
                        equipoAlumno[i].canonNo();
                    end;
            end
    end;

procedure TfrmMain.mnuLanzarAplicaClick(Sender: TObject);
    begin
        f_PantallaActiva:=6;
        menusclick(mnuLanzarAplica,f_PantallaActiva,pnlan,spapl);
    end;

procedure TfrmMain.mnuManualClick(Sender: TObject);
    var
        pdf:string;
    begin
        pdf := '/usr/bin/acroread';
        if fileexists('/usr/bin/acroread') then
            pdf:='/usr/bin/acroread'
        else if fileexists('/usr/bin/evince') then
            pdf:='/usr/bin/evince'
        else if fileexists('/usr/bin/gpdf') then
            pdf:='/usr/bin/gpdf'
        else if fileexists('/usr/bin/kghostview') then
            pdf:='/usr/bin/kghostview';
        pdf:= pdf + ' /usr/share/doc/aulalinex-profesor-ltsp/manual_aulalinex.pdf &';
         Ejecutar(pdf);
    end;

procedure TfrmMain.mnuMensajeClick(Sender: TObject);
    begin
        f_PantallaActiva:=3;
        menusclick(mnumensaje,f_PantallaActiva,pnmen,spmen);
     end;

procedure TfrmMain.mnuMostrarClick(Sender: TObject);
    begin
        f_PantallaActiva:=2;
        menusclick(mnuMostrar,f_PantallaActiva,pnmos,spmos);
        IniciarServidorVnc();
    end;

procedure TfrmMain.mnuMostrarVlcClick(Sender: TObject);
    begin
        f_PantallaActiva:=10;
        MenusClick(mnuMostrar,f_PantallaActiva,pnVlc,spvid);
    end;

procedure TfrmMain.mnuNavegarClick(Sender: TObject);
   begin
        f_PantallaActiva:=7;
        if not fileexists(equipoProfesor.ArcFavoritosWeb)then
            begin
                lstpag.Items.Add('http://www.educarex.es');
                lstpag.Items.SaveToFile(equipoProfesor.ArcFavoritosWeb);
            end;
        lstpag.Items.LoadFromFile(equipoProfesor.ArcFavoritosWeb);
        menusclick(mnuNavegar,f_PantallaActiva,pnnav,spnav);
    end;


procedure TfrmMain.mnuNotClick(Sender: TObject);
    const
        P_BLOC:string='gedit';
    begin
        ordenesaula(ORD_EJECUTAR_EN_PROFE,[P_BLOC]);
    end;

procedure TfrmMain.mnuPresentaAluClick(Sender: TObject);
    begin
       f_PantallaActiva:=11;
       IniciarServidorVnc();
       iniciarvnc(-1);
       MenusClick(mnuPresentaAlu,f_PantallaActiva,pnalu,spalu);
       application.ProcessMessages;
    end;

procedure TfrmMain.mnuProgramasClick(Sender: TObject);
    begin
        iniciarvnc(-1);
        TfrmProcesos.create(self).ShowModal
    end;

procedure TfrmMain.mnuRecibirArchivoClick(Sender: TObject);
    begin
        f_PantallaActiva:=5;
        menusclick(mnuRecibirArchivo,f_PantallaActiva,pnrec,sprec);
    end;

procedure TfrmMain.mnuRefrescarClick(Sender: TObject);
    var
        i:integer;
    begin
        mnuRefrescar.enabled:=false;
        for i:=0 to high(equipoalumno) do
            equipoalumno[i].RefrescarEncendido;
        mnurefrescar.enabled:=true;
    end;

procedure TfrmMain.mnuRestaurarAulaClick(Sender: TObject);
    var
        i:integer;
    begin
        g_GrupoPertenece:=false;
        f_grupo:=false;
        f_MostrarUsuarios:=true;
        for i:=0 to high(spGrupos) do
        spGrupos[i].Visible:=false;
        for i:= 0 to g_num_ord_aula -1 do
            begin
                lblordenata[i].Visible:=true;
                lblOrdenata[i].Caption:=NombreUsuarioOrdenador(i);

                lblmesa[i].Visible:=false;
                if equipoalumno[i].EstadoActivadEquipo<>eAveriado then;
                    begin
                       Ordenata[i].Enabled:=true;
                       spDarRaton[i].Enabled:=true;
                    end;

            end;
        for i:=g_num_ord_aula to g_num_ord_pantalla-1 do
                lblOrdenata[i].Caption:='';

        ComprobarEstadoordenadores(f_PantallaActiva);
        lblgrupo.Caption:='';
    end;

procedure TfrmMain.mnuSalirClick(Sender: TObject);
    begin
        close;
    end;

procedure TfrmMain.mnuUsuariosClick(Sender: TObject);
    var
        i: integer;
    begin

        f_MostrarUsuarios:=true;
        g_GrupoPertenece:=false;

        f_grupo:=false;
        for i:=0 to high(spGrupos) do
            spGrupos[i].Visible:=false;
        for i:= 0 to g_num_ord_aula -1 do
            begin
                lblOrdenata[i].Caption:=NombreUsuarioOrdenador(i) ;
                Application.ProcessMessages;
                lblordenata[i].Visible:=true;
                lblmesa[i].Visible:=true;
                if equipoalumno[i].EstadoActivadEquipo<>eAveriado  then;
                    begin
                       Ordenata[i].Enabled:=true;
                       spDarRaton[i].Enabled:=true;
                    end;             end;
        ActualizarMonitores();
        lblgrupo.Caption:='';
    end;

procedure TfrmMain.mnuVerClick(Sender: TObject);
    begin
        iniciarvnc(-1);
        f_PantallaActiva:=1;
        menusclick(mnuver,f_PantallaActiva,pnver,spver);
        application.ProcessMessages;
    end;

procedure TfrmMain.mnuVerPreClick(Sender: TObject);
    begin
        pnfondo.BringToFront;
        pnfondo.Align:=alclient;
        application.ProcessMessages;
        pnfondo.Visible:=true;
        tfrmelegir.Create(nil).showmodal;
        frmelegir.Free;
        pnFondo.Visible:=false;
    end;


procedure TfrmMain.RadioButton8Click(Sender: TObject);
    var
       i, index:integer;
    begin
        index:=0;
        for i:=0 to pnTipoVlc.ControlCount -1 do
            if pnTipoVlc.controls[i] is Tradiobutton then
                if (pnTipoVlc.controls[i] as Tradiobutton).Checked =true  then
                    index:=(pnTipoVlc.controls[i] as Tradiobutton).tag;
        case index of
            0:
                begin
                    btncarvlc.Enabled:=true;
                    btniniciar.Enabled:=false;
                    edNomvlc.Text:='';
                end;
            1:
                begin
                    btncarvlc.Enabled:=false;
                    btniniciar.Enabled:=true;
                    edNomvlc.Text:='Reproducir DVD';
                end;
            2:
                begin
                    btncarvlc.Enabled:=false;
                    btniniciar.Enabled:=true;
                    edNomvlc.Text:='Reproducir VCD';
                end
        end;
    end;

procedure TfrmMain.spBloClick(Sender: TObject);
    var
        botonpulsado:integer;
    begin
        botonpulsado:=(sender as Tspeedbutton).Tag;
        case botonpulsado of
            0:mnuEncenderClick(mnuencender);
            1:mnuVerClick(mnuVer);
            2:mnuMostrarClick(mnuMostrar);
            3:mnuDesactivarClick(mnuDesactivar);
            4:mnuMensajeClick(mnuMensaje);
            5:mnuEnviarArchivoClick(mnuEnviarArchivo);
            6:mnuEnvCarClick(mnuEnvCar);
            7:mnuRecibirArchivoClick(mnuRecibirArchivo);
            8:mnuDevTodClick(mnuDevTod);
            9:mnuLanzarAplicaClick(mnuLanzarAplica);
            10:mnuNavegarClick(mnuNavegar);
            13:mnuMostrarVlcClick(mnuMostrarVlc);
            11:mnuVerPreClick(mnuVerPre);
            12:mnuPresentaAluClick(mnuPresentaAlu);
            14:mnuCamaraClick(mnuCamara);
            16:mnuDesactivarTRClick(mnuDesactivar);
            17:mnuExamenClick(mnuExamen);
            18:mnuIniEvaClick(mnuIniEva);
        end;
    end;

procedure TfrmMain.Timer2Timer(Sender: TObject);
    begin
        inc(f_contadorinicio);
        if  f_contadorinicio=1 then
            visible := true
       else if (f_contadorinicio >2) and pnPresenta.Visible then
            begin
                ImgPresentaClic();
                timer2.Enabled:=false;
            end;
    end;

procedure TfrmMain.tmrBarraTimer(Sender: TObject);
    var
       nunequ:integer;
    begin
        nunequ:=(sender as TTimer).Tag;
        inc(fcontadorbarra[nunequ]);
        if fcontadorbarra[nunequ]>60 then fcontadorbarra[nunequ]:=0;
        pgOrdenata[nunequ].Progress:=fcontadorbarra[nunequ]
    end;

procedure TfrmMain.tmrExamenTimer(Sender: TObject);
    begin
        if g_contadorExamen<=0 then
        begin
             tmrExamen.enabled:=false;
             mensaje(MEN_TIEMPO_EXAMEN_FIN,aceptar);
         end;
        lblExamen.caption:=Tiempo(g_contadorExamen);
    end;

procedure TfrmMain.Video1Click(Sender: TObject);
    const
        P_VIDEO:string='vlc';
    begin
        ordenesaula(ORD_EJECUTAR_EN_PROFE,[P_VIDEO])
    end;


initialization
  {$I inicio.lrs}

end.

