unit globales ; 

{$mode objfpc}{$H+}

interface 
uses
  unix,Classes, SysUtils,process,IniFiles;

const
     PUERTO_ROOT:integer=36999;
var
    fdirpersonal:string;
    fdirrecibidos:string;
    fusuario:string;
    fenviar:string;
    fcontadorPing:integer=0;
    fTiempoPing:integer=20;
    fapagando:boolean=false;
    fmipuerto:integer;


g_maquina_profe:boolean=false;
g_finalizar:boolean=false;
g_dirmensaje:string;
procedure MatarAplicacion(aplica:String);
procedure Ejecutar1 (comando:string);
function CrearArchivoMensaje(TipoMensaje,AsuntoMensaje,ContenidoMensaje:string; ArchivoMensaje:String='0'):boolean;
function HallarDatos(Cmd:string):String;

implementation

function HallarDatos(Cmd:string):String;
    var
        file1: TextFile;
        s,t: ansistring;
        n: longint;
        j:integer;
    begin
        j:=0;
        n:=popen(file1, Cmd, 'r');
        if n=-1 then
            begin
                result:='';
                writeln('Error al hallar dato');
                Exit;
            end;
        t:='';
        while not eof(file1) do begin
            Readln(File1,s);
            t:=t+s+Chr(10);
            inc(j);
        end;
        pclose(file1);
        result := trim(t);
    end;
procedure Ejecutar1 (comando:string);
    begin;
          unix.fpSystem(comando);
    end;
procedure MatarAplicacion(aplica:String);
    const
        ORDEN_MATAR:STRING='killall %s & 2>>/dev/null';

    var
        orden:string;
    begin
        orden:=format(ORDEN_MATAR,[aplica]);
        unix.fpSystem(orden);
    end;
function CrearArchivoMensaje(TipoMensaje,AsuntoMensaje,ContenidoMensaje:string; ArchivoMensaje:String='0'):boolean;
     const
        NOMBRE_ALUMNO:string='aulalinex-alumno';     var
        Mifichero:TMemIniFile;
     begin
        result:=true;
        if fileexists(g_dirmensaje) then DeleteFile(g_dirmensaje);
        try
            Mifichero := TMemIniFile.Create(g_dirmensaje);
            with Mifichero do
                begin
                    WriteString('MENSAJE','mensaje',ContenidoMensaje);
                    WriteString('MENSAJE','tipo', TipoMensaje);
                    WriteString('MENSAJE','titulo',AsuntoMensaje);
                    WriteString('MENSAJE','tiempo','30');
                    WriteString('MENSAJE','usuario',NOMBRE_ALUMNO);
                    WriteString('MENSAJE','archivo',ArchivoMensaje);
                    UpdateFile;
                    Free;
                end;
                sleep(2000);
        except
            begin
                 result:=false;
                 writeLn('Error al crear archivo');
            end;
        end;
    end;




end.

