{
  Aulalinex 3.2-0 Software de gestin de Aulas Tecnolgicas
  Copyright (C) 2008-2009, Consejera de Educacin,Junta de Extremadura
  Programacin: Manuel Narvez Martnez  <mnarvaez007@gmail.com>
  Diseo grfico: Ana Mara Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit clequipoalumno;
interface
uses  clpingequipo,IdURI,globales,StrUtils,ExtCtrls,SysUtils,clcomandos,clcomandosroot,clver,clcuestion,clenviararchivo,clenviarcarpeta,clexamen, clpresentador,clrecibir,cldevolver;
type

   { Tequipo }

   Tequipo= class
       private
            fFotoAlumno:string;
            fRelojEncendiendo:Boolean;
            fEstadoActividadEquipo:TEstadoActividadEquipo;
            fFinEncendiendo:Boolean;
            fFinApagando:Boolean;
            fMiNumero:integer;
            fmihost,fmac,fIP:String;
            fUsuarioActivo:string;
            fNombreMonitor:string;
            fGruposActivados:Boolean;
            fNombreMiembroGrupo:string;
            fPuerto:integer;
            fPuertoVNC:integer;
            fordenpidvnc:string;
            FPoseoRaton:Boolean;
            fL,fT:integer;
            fcuestion_respuesta:integer;
            fcuestion_tiempo:integer;
            fcuestion_resultado:integer;
            fcuestion_terminada:boolean;
            fcuestion_hace:boolean;
            fexamen_tipo:integer;
            fexamen_numopciones:integer;
            fexamen_tiempo:integer;
            fexamen_tiempo_examen:integer;
            fexamen_aciertos:integer;
            fexamen_fallos:integer;
            fexamen_blancos:integer;
            fexamen_numpreguntas:integer;
            fexamen_nota:double;
            fexamen_terminado:boolean;
            fexamen_hace:Boolean;
            fexamen_datos_individual:string;
            tmrPing:TTimer;
            tmrEncendiendo:TTimer;
            tmrApagando:TTimer;
            fcontadorping:integer;
            fEncendiendoContador:integer;
            fApagandoContador:integer;
            procedure actualizarEstadoEquipo();
            procedure DevolverArchivos(comando, carpeta: string);
            procedure EjecutarComandos(codigo:integer;comando:string);
            procedure EjecutarComandosRoot ( mhost:string;codigo : integer ; comando : string);
            procedure EnviarCarpeta(comando,carpeta: string);
            function getNombreMonitor: string;
            procedure mensajeNo();
            procedure archivo();
            procedure archivoNo();
            procedure recibir();
            procedure recibirNo();
            procedure lanzar();
            procedure lanzarNo();
            procedure navegar();
            procedure navegarNo();
            procedure devolver();
            procedure carpeta();
            procedure carpetaNo();

            function TituloMesaVnc(nm: string): string;
            procedure EnviarArchivos(comando,miarchivo:string);
            procedure recogerArchivos(usuario,comando:string;mcarpeta:string);
            procedure EjecutarVer(comando: string);
            procedure EjecutarPresentador(arcontra,comando: string);
            procedure EnviarCuestion(comando,miarchivo:string);
            procedure tmrPingTimer(sender: TObject);
            procedure tmrApagandoTimer(sender: Tobject);
            procedure tmrEncendiendoTimer(sender: Tobject);

       public
           fIconoMonitor:Array of Integer;
           fMonitorPulsado:Array of Boolean;
           constructor create(numero:integer;host,ip,mac:string;estado:boolean);
           destructor Destroy; override;
           property EstadoActivadEquipo:TEstadoActividadEquipo read fEstadoActividadEquipo write fEstadoActividadEquipo;
           property mihost:string read Fmihost write Fmihost;
           property IP:string read fIP write fIP;
           property Puerto:integer read fPuerto write fPuerto;
           property PuertoVNC:integer read fPuertoVNC write fPuertoVNC;
           property MAC:string read fMAC write fMAC;
           property UsuarioActivo:string read fUsuarioActivo write fUsuarioActivo;
           property NombreMonitor:string read getNombreMonitor;
           property PoseoRaton:Boolean read FPoseoRaton write FPoseoRaton;
           property L:integer read fL write fL;
           property T:integer read fT write fT;
           property FotoAlumno:String read fFotoAlumno write fFotoAlumno;
           property CuestionTerminada:Boolean read fcuestion_terminada write fcuestion_terminada;
           property CuestionHace:Boolean read fcuestion_hace write fcuestion_hace;
           property CuestionRespuesta:integer read fcuestion_respuesta write fcuestion_respuesta;
           property CuestionTiempo:integer read fcuestion_tiempo write fcuestion_tiempo;
           property CuestionResultado:integer read fcuestion_resultado write fcuestion_resultado;
           property ExamenTipo:integer read fexamen_tipo write fexamen_tipo;
           property ExamenNumOpciones:integer read fexamen_numopciones write fexamen_numopciones;
           property ExamenTiempo:integer read fexamen_tiempo write fexamen_tiempo;
           property ExamenTiempoExamen:integer read fexamen_tiempo_examen write fexamen_tiempo_examen;
           property ExamenAciertos:integer read fexamen_aciertos write fexamen_aciertos;
           property ExamenFallos:integer read fexamen_fallos write fexamen_fallos;
           property ExamenBlancos:integer read fexamen_blancos write fexamen_blancos;
           property ExamenNumPreguntas:integer read fexamen_tiempo write fexamen_tiempo;
           property ExamenNota:double read fexamen_nota write fexamen_nota;
           property ExamenTerminado:Boolean read fexamen_terminado write fexamen_terminado;
           property ExamenHace:Boolean read fexamen_hace write fexamen_hace;
           property ExamenDatosIndividual:string read fexamen_datos_individual;
           procedure ElegirOrden(numpant:integer;mestado:boolean);
           Function IconoEquipo(numpan:integer):integer;
           property NombreMiembroGrupo:string read fNombreMiembroGrupo  write fNombreMiembroGrupo;
           property RelojEncendiendo:Boolean read fRelojEncendiendo;
           procedure mostrar();
           procedure mostrarNo;
           procedure mensaje();
           procedure presentar();
           procedure verNo();
           procedure ver();
           procedure RefrescarEncendido;
           procedure ApagaSalva;
           procedure internet();
           procedure internetNo();
           procedure raton();
           procedure ratonNo();
           procedure Bloquear;
           procedure BloquearNo;
           procedure encender();
           procedure encenderNo();
           procedure canon(usu:string);
           procedure canonNo();
           procedure video();
           procedure videoNo();
           procedure cierraUsuario();
           procedure limpiarArchivos();
           procedure iniciarCuestion();
           procedure iniciarClientesVNC();
           procedure iniciarExamen();
           procedure EnviarExamen(comando,miarchivo:string);
           procedure devolverExamenCorregido();
           procedure cargarRespuestasExamen(soluciones:string;respuestas:string='';tiempo:integer=0);
           function ObtenerPuerto(myip:string):integer;
           function ObtenerProcesos(): string;
           ExamenRespuestas:array of Integer;
           ExamenSoluciones:array of integer;
           procedure cargarEvaluacionCuestion(solucion: integer; respuesta: integer=0; tiempo: integer=30);
           procedure IniciarRelojes();
           procedure PararRelojApagando();
           procedure PararRelojEncendiendo();
           procedure pararRelojPing(estado:Boolean);

   end;
   const
      NUM_PANTALLAS:integer=15;
      TIEMPO_ENCENDIENDO:INTEGER=50;
      TIEMPO_APAGANDO:INTEGER=6;

implementation

uses inicio,globales1;
procedure Tequipo.actualizarEstadoEquipo();
    begin
        if fEstadoActividadEquipo=eAveriado then exit;
        tmrPing.enabled:=false;
        fcontadorping:=0;
        with ThrPingEquipo.create(fPuerto,fMiNumero,fIP,fEstadoActividadEquipo,fUsuarioActivo,fFinEncendiendo,fFinApagando) do Resume;
        tmrPing.enabled:=true;
    end;

procedure Tequipo.iniciarClientesVNC();
    var
        orden:string;
    begin
        orden:='ver ' + equipoProfesor.ContraVNCAlumno+' '+ equipoProfesor.host;
        EjecutarComandos(210,orden);
    end;

function Tequipo.ObtenerPuerto(myip:string):integer;
    const
        ORDEN_IP:string='echo %s | cut -f4 -d"."';
    var
        miequipo1:string;
        finalport:integer;
        ordp:string;
    begin
        ordp:=Format(ORDEN_IP,[myip]);
        miequipo1:=HallarDato(ordp);
        try
            finalport:=strtoint(miequipo1)
        except
             finalport:=99;
        end;
        fPuertoVNC:=5900+finalport;
        result:=37000+finalport;
    end;

procedure Tequipo.cargarEvaluacionCuestion(solucion:integer;respuesta:integer=0;tiempo:integer=30);
    begin
           fcuestion_terminada:=true;
           fcuestion_tiempo:=tiempo;
           fcuestion_respuesta:=respuesta;
           if fcuestion_respuesta = 0 then
              fcuestion_resultado:=0
           else if fcuestion_respuesta=solucion then
                fcuestion_resultado:=1
           else
               fcuestion_resultado:=2;
    end;

procedure Tequipo.IniciarRelojes();
    begin
        // pingUsuario();
         fcontadorping:=g_tiempo_ping-3;
         tmrPing.Enabled:=true;
         tmrEncendiendo.Enabled:=false;
         tmrApagando.Enabled:=false;
    end;
procedure Tequipo.PararRelojEncendiendo();
    begin
         tmrEncendiendo.Enabled:=false;
    end;
 procedure Tequipo.PararRelojApagando();
    begin
         tmrApagando.Enabled:=false;
    end;
procedure TEquipo.pararRelojPing(estado:Boolean);
    begin
        tmrPing.enabled:=estado
    end;
procedure Tequipo.cargarRespuestasExamen(soluciones:string;respuestas:string='';tiempo:integer=0);
    var
        i,tamano:integer;
    begin
           fexamen_terminado:=true;
           tamano:=length(trim(respuestas));
           fexamen_aciertos:=0;
           fexamen_fallos:=0;
           fexamen_blancos:=0;
           fexamen_nota:=0;
           fexamen_tiempo:=tiempo;
            if (tamano=0) then
                begin
                        tamano:=length(soluciones);
                        setlength(ExamenRespuestas,tamano);
                        setlength(ExamenSoluciones,tamano);
                        fexamen_blancos:=tamano;
                        for i:=0 to high(ExamenRespuestas)do
                            begin
                                ExamenRespuestas[i]:=0;
                                ExamenSoluciones[i]:=strtoint(MidStr(soluciones,i+1,1));
                            end;
                end
             else
                    begin
                        tamano:=length(soluciones);
                        setlength(ExamenRespuestas,tamano);
                        setlength(ExamenSoluciones,tamano);
                        for i:=0 to high(ExamenRespuestas) do
                            begin
                                ExamenRespuestas[i]:=strtoint(MidStr(respuestas,i+1,1));
                                ExamenSoluciones[i]:=strtoint(MidStr(soluciones,i+1,1));
                                if ExamenRespuestas[i]=0  then
                                    inc(fexamen_blancos)
                                else if ExamenRespuestas[i]=ExamenSoluciones[i] then
                                    inc(fexamen_aciertos)
                                else
                                    inc(fexamen_fallos);
                            end;
                end;
       fexamen_numpreguntas:=tamano;
       fexamen_nota:=(fexamen_aciertos*10)/fexamen_numpreguntas;
    end;

procedure Tequipo.iniciarExamen();
    var
        orden_examen:string;
    begin
        orden_examen:='iniciarExamen ' + equipoProfesor.ArcExamen ;
        EnviarExamen(orden_examen,equipoProfesor.ArcExamen);
    end;

procedure Tequipo.devolverExamenCorregido();
    var
        orden_examen:string;
    begin
        orden_examen:='iniciarExamen ' + equipoProfesor.ArcExamenCorregido ;
        EnviarExamen(orden_examen,equipoProfesor.ArcExamenCorregido);
    end;

procedure  Tequipo.EnviarExamen(comando,miarchivo:string);
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
         with ThrExamen.create(fPuerto,fIP,comando,miarchivo) do Resume;
    end;

procedure Tequipo.iniciarCuestion();
    var
        orden_cuestion:string;
    begin
        orden_cuestion:='iniciarCuestion' ;
        EnviarCuestion(orden_cuestion,equipoProfesor.ArcCuestion);
    end;

procedure  Tequipo.EnviarCuestion(comando,miarchivo:string);
    begin
        if fEstadoActividadEquipo <> eUsuario then exit;
        with ThrCuestion.create(fPuerto,fIP,comando,miarchivo) do Resume;
    end;

procedure Tequipo.limpiarArchivos();
    var
        orden_limpiar:string;
    begin
        orden_limpiar:='limpiar ' + g_tipo_limpieza_archivos ;
        EjecutarComandos(225,orden_limpiar);
    end;

procedure Tequipo.Canon(usu:string);
    var iniciacanon:string;
    begin
          iniciacanon:='iniciarCanon ' +usu+ ' 007momy';
          EjecutarComandosRoot(fIP,313,iniciacanon);

    end;

procedure Tequipo.CanonNo();
    begin
          EjecutarComandosRoot(fIP,314,'terminarCanon')
    end;

procedure Tequipo.RefrescarEncendido;
    begin
        tmrPing.enabled:=false;
        fcontadorping:=g_tiempo_ping+1;
        tmrPing.enabled:=true;
    end;

procedure Tequipo.ApagaSalva;
    begin
          if fEstadoActividadEquipo <> eUsuario then exit;
          EjecutarComandos(226,'apagarSalva');
    end;


Function Tequipo.IconoEquipo(numpan:integer):integer;
    begin
        result :=fIconoMonitor[numpan];
    end;

procedure TEquipo.ElegirOrden(numpant:integer;mestado:boolean);
    begin
        if fEstadoActividadEquipo=eAveriado then Exit;
        case numpant of
            0://eEncender:
                begin
                    if mestado then
                        begin
                             encender();
                        end
                    else
                        begin
                            encenderNo();
                        end;
                end;
            1://eVer:
                begin
                    if mestado then
                        begin
                            ver();
                        end
                    else
                        begin
                            verNo();
                        end;
                end;
            2://eMostrar:
                begin
                    if mestado then
                        begin
                            mostrar();
                        end
                    else
                        begin
                            mostrarNo();
                        end;
                end;
            3://eMensaje:
                begin
                    if mestado then
                        begin
                            mensaje();
                        end
                    else
                        begin
                            mensajeNo();
                        end;
                end;
            4://eArchivo:
                begin
                    if mestado then
                        begin
                            archivo();
                        end
                    else
                        begin
                            //archivoNo();
                        end;
                end;
            5://eRecibir:
                begin
                    if mestado then
                        begin
                            recibir();
                        end
                    else
                        begin
                            recibirNo();
                        end;
                end;
            6://eLanzar:
                begin
                    if mestado then
                        begin
                            lanzar();
                        end
                    else
                        begin
                            lanzarNo();
                        end;
                end;
            7://eNavegar:
                begin
                    if mestado then
                        begin
                            navegar();
                        end
                    else
                        begin
                            navegarNo();
                        end;
                end;
            8://eDevolver:
                begin
                    if mestado then
                        begin
                            devolver();
                        end
                    else
                        begin
                           //devolverNo();
                        end;
                end;
            9://eCarpeta:
                begin
                    if mestado then
                        begin
                            carpeta();
                        end
                    else
                        begin
                            carpetaNo();
                        end;
                end;
            10://eVideo:
                begin
                    if mestado then
                        begin
                            video();
                        end
                    else
                        begin
                            videoNo();
                        end;
                end;
            11://ePresentar:
                begin
                    if fMonitorPulsado[numpant]=false then
                        begin
                           // presentar(parametros);
                        end
                    else
                        begin
                           // presentarNo();
                        end;
                end;
            12://eInternet:
                begin
                    if mestado then
                        begin
                              internetNo();
                        end
                    else
                        begin
                               internet();
                        end;
                end;
            13://bloquear teclado y ratn:
                begin
                    if mestado then
                        Bloquear()
                    else
                        BloquearNo();
                end;
            14://raton:
                begin
                    if mestado then
                        raton()
                    else
                        ratonNo();
                 end;
           end;
        fMonitorPulsado[numpant]:=mestado;
        if mestado then
            fIconoMonitor[numpant]:=1
        else
            fIconoMonitor[numpant]:=0;
    end;

destructor Tequipo.Destroy;
    begin
        FreeAndNil(tmrPing);
        FreeAndNil(tmrApagando);
        FreeAndNil(tmrEncendiendo);
        FreeAndnil(fIconoMonitor);
        FreeAndnil(fMonitorPulsado);
        inherited Destroy;
    end;

constructor TEquipo.create(numero:integer;host,ip,mac:string;estado:Boolean);
    var
        i:integer;
    begin
       inherited Create;
        if estado=false then
           fEstadoActividadEquipo:=eAveriado
       else
       fEstadoActividadEquipo:=eApagado;
       fRelojEncendiendo:=false;
       fUsuarioActivo:='';
       fFotoAlumno:='';
       fFinEncendiendo:=false;
       fFinApagando:=False;
       fGruposActivados:=false;
       fcontadorping:=g_tiempo_ping-2;
       fEncendiendoContador:=0;
       fApagandoContador:=0;
       fNombreMonitor:= 'Mesa '+ inttostr(numero+1);
       fNombreMiembroGrupo:=fNombreMonitor;
       Fminumero:=numero;
       fPoseoRaton:=false;
       fmihost:=host;
       fip:=ip;

       fpuerto:=ObtenerPuerto(ip);
       fmac:=mac;
       setlength(fMonitorPulsado,NUM_PANTALLAS);
       setlength(fIconoMonitor,NUM_PANTALLAS);
       for  i:=0 to NUM_PANTALLAS -1 do
           begin
              fMonitorPulsado[i]:=false;
              fIconoMonitor[i]:=0;
              if  fEstadoActividadEquipo=eAveriado then fIconoMonitor[i]:=2;
           end;
       tmrPing:=TTimer.create(nil);
       tmrPing.onTimer:=@tmrPingTimer;
       tmrPing.interval:=1000;
       tmrPing.Enabled:=false;
       tmrEncendiendo:=TTimer.create(nil);
       tmrEncendiendo.onTimer:=@tmrEncendiendoTimer;
       tmrEncendiendo.interval:=1000;
       tmrEncendiendo.Enabled:=false;
       tmrApagando:=TTimer.create(nil);
       tmrApagando.onTimer:=@tmrApagandoTimer;
       tmrApagando.interval:=1000;
       tmrApagando.Enabled:=false;
    end;

procedure Tequipo.tmrApagandoTimer(sender:Tobject);
    begin
         inc(fApagandoContador);
         if fApagandoContador>=TIEMPO_APAGANDO then
             begin
                 tmrApagando.Enabled:=false;
                 fApagandoContador:=0;
                 fFinApagando:=true;
                 actualizarEstadoEquipo();
               end;
    end;

procedure Tequipo.tmrEncendiendoTimer(sender:Tobject);
    begin
         inc(fEncendiendoContador);
         if fEncendiendoContador>=TIEMPO_ENCENDIENDO then
             begin
                 tmrEncendiendo.Enabled:=false;
                 fEncendiendoContador:=0;
                 fFinEncendiendo:=true;
                 actualizarEstadoEquipo();
             end;
    end;

procedure  Tequipo.EjecutarComandos(codigo:integer;comando:string);
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
         with ThrComandos1.create(fPuerto,codigo,fIP,comando) do Resume;
    end;

procedure  Tequipo.EjecutarComandosRoot( mhost:string;codigo:integer;comando:string);
    begin
         with ThrComandosRoot.create(codigo,mhost,comando) do Resume;
    end;

procedure  Tequipo.EjecutarVer(comando:string);
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
         with ThrVer.create(equipoProfesor.ArcContraVNC,fPuertoVNC,fPuerto,g_num_ord_aula,FmiNumero,comando,g_modoobservacion,g_tipoobservacion,fUsuarioActivo,fIp,equipoProfesor.host) do Resume;
    end;

procedure  Tequipo.EjecutarPresentador(arcontra,comando:string);
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
         with thrPresendador.create(arcontra,fPuertoVNC,fPuerto,comando,fUsuarioActivo,fIP) do Resume;
    end;


procedure TEquipo.tmrPingTimer(sender:TObject);
    begin
          if  fContadorPing>= g_tiempo_ping then
              begin
                 fContadorPing:=0;
                 actualizarEstadoEquipo();
              end;
        inc(fContadorPing);
    end;

procedure  Tequipo.EnviarArchivos(comando,miarchivo:string);
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
         with ThrEnviar.create(fPuerto,fIP,comando,miarchivo) do Resume;
    end;

procedure  Tequipo.EnviarCarpeta(comando,carpeta:string);
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
         with ThrEnviarCarpeta.create(Fminumero,fPuerto,fIP,comando,carpeta) do Resume;
    end;

function Tequipo.getNombreMonitor: string;
    begin
        if g_GrupoPertenece then
           begin
               if trim(fNombreMiembroGrupo) <> '' then
                   result:=fNombreMiembroGrupo
               else
                   result:='Mesa ' + inttostr(Fminumero+1);
           end
        else if fUsuarioActivo<>''then
            result:=fUsuarioActivo
        else
           result:=fNombreMonitor;
    end;

procedure Tequipo.encender();
    const
        ORD_ENCENDER:STRING= 'wakeonlan -i 192.168.0.255 -p 2000 %s  &';
    var
        orden:string;
    begin
        if fEstadoActividadEquipo =eApagado then;
            begin
                fcontadorping:=0;
                fEstadoActividadEquipo:=eEncendiendo;
                fFinEncendiendo:=false;
                fFinApagando:=false;
                fEncendiendoContador:=0;
                tmrEncendiendo.Enabled:=true;
                orden:=format(ORD_ENCENDER,[fMAC]);
                Ejecutar(Orden);
                actualizarEstadoEquipo();
            end;
    end;

procedure Tequipo.EncenderNo();
    begin
          if fEstadoActividadEquipo in [eEncendido,eUsuario] then
              begin
                  EjecutarComandosRoot(fIP,302,'ApagarEquipo');
                  fFinEncendiendo:=false;
                  fFinApagando:=false;
                  fEstadoActividadEquipo:=eApagando;
                  fApagandoContador:=0;
                  tmrApagando.Enabled:=true;
                  if trim(fUsuarioActivo)<>'' then  cierraUsuario();

              end;
    end;

procedure Tequipo.ver();
    var
        orden_ver:string;
    begin
        orden_ver:='ver ' + equipoProfesor.ContraVNCAlumno+' '+ equipoProfesor.host ;
        EjecutarVer(orden_ver);
    end;

Function Tequipo.TituloMesaVnc(nm:string):string;
    begin
         result:=quotedstr(nm);
    end;

procedure Tequipo.verNo();
    const
         ORDEN_APAGAR:string='kill -9 %s';
    var
         puertovnc1,orden,mipid:string;
    begin
        puertovnc1:=inttostr(fpuertoVNC);
        fordenpidvnc:='ps eauxww | grep xvnc4viewer | grep ' + puertovnc1 + ' | grep -v grep | awk ' + QuotedStr('{print $2}');
        mipid:= hallarDato(fordenpidvnc);
        if trim(mipid) = '' then exit;
        orden:=Format(ORDEN_APAGAR, [mipid]);
        Ejecutar(orden)
    end;

procedure Tequipo.mostrar();
    var
        orden_mostrar:string;
    begin
        orden_mostrar:='mostrar ' + equipoProfesor.ContraVNCProfe;
        EjecutarComandos(212,orden_mostrar);
    end;

procedure Tequipo.mostrarNo;
   begin
        EjecutarComandos(213,'mostrarNo');
   end;

procedure Tequipo.mensaje();
    var
        orden:string;
    begin
        orden:='mensaje$' + g_mensaje_prioridad+'$'+ g_mensaje_asunto+'$'+ g_mensaje_texto;
        EjecutarComandos(204,orden);
    end;

procedure Tequipo.mensajeNo();
    begin
        EjecutarComandos(205,'mensajeNo');
    end;

procedure Tequipo.archivo();
    var
        nombrearchivo,orden:string;
    begin
        nombrearchivo:=TIdURI.ParamsEncode(g_archivo_nombre);
        orden:='archivo ' + nombrearchivo+' ' + g_mensaje_texto+' '+g_mensaje_asunto;
        EnviarArchivos(orden,g_archivo_path);
    end;

procedure Tequipo.archivoNo();
    begin
      //EjecutarComandos('encenderNo')
    end;

procedure Tequipo.recibir();
    var
        orden:string;
        micarpeta:string;
    begin
        if fEstadoActividadEquipo <> eUsuario then exit;
        //EjecutarComandos(216,'prepararRecoger');
        micarpeta:=g_carpeta_recibir_path+PathDelim+fUsuarioActivo;
        if not DirectoryExists(micarpeta) then
                forcedirectories(micarpeta);
        orden:='recogerArchivos '+micarpeta +' ' + g_mensaje_texto+' '+g_mensaje_asunto;
        recogerArchivos(fUsuarioActivo,orden,micarpeta)
    end;

procedure Tequipo.recogerArchivos(usuario,comando:string;mcarpeta:string);
    begin
        if fEstadoActividadEquipo <> eUsuario then exit;
        with ThrRecibir.create(fPuerto,usuario,fIP,comando,mcarpeta) do Resume;
    end;



procedure Tequipo.recibirNo();
    begin
      //EjecutarComandos('encenderNo')
    end;

procedure Tequipo.Lanzar();
    var
        orden:string;
    begin
        if g_nombreAplicacion1='' then exit;
        orden:='aplicacion ' + g_nombreAplicacion1;
        EjecutarComandos(206,orden);
    end;

procedure Tequipo.LanzarNo();
    var
        orden:string;
    begin
        if g_nombreAplicacion1='' then exit;
        orden:='aplicacionNo ' + g_nombreAplicacion1;
        EjecutarComandos(207,orden);
    end;

procedure Tequipo.navegar();
    const
        WEB_INICIO:string='http://www.educarex.es';
    var
        Pagina_navegar:string;
        orden_navegar:string;
    begin
        pagina_navegar:=ifthen(length(g_webnavegar)< 5,WEB_INICIO,trim(g_webnavegar));
        orden_navegar:='navegar ' + pagina_navegar;
        EjecutarComandos(202,orden_navegar);
    end;

procedure Tequipo.navegarNo();
    begin
        //EjecutarComandos(203,'navegarNo');
    end;

procedure Tequipo.Devolver();
    var
       carpetadev:string;
       orden_devolver:string;
    begin
        if fEstadoActividadEquipo <> eUsuario then exit;
        carpetadev:= g_carpeta_devolver_path+PathDelim+fUsuarioActivo;
        if not DirectoryExists(carpetadev) then exit;
        orden_devolver:='devolverArchivos '+g_carpeta_devolver_nombre +' ' + g_mensaje_texto+' '+g_mensaje_asunto ;
        DevolverArchivos(orden_devolver,carpetadev);
    end;

procedure  Tequipo.DevolverArchivos(comando,carpeta:string);
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
         with ThrDevolverArchivos.create(fPuerto,fIP,comando,carpeta) do Resume;
    end;

procedure Tequipo.Carpeta();
    var
        orden_carpeta:string;
    begin
        orden_carpeta:='carpeta '+ g_mensaje_texto+' '+g_mensaje_asunto;
        EnviarCarpeta(orden_carpeta,g_carpeta_enviar_path);
    end;

procedure Tequipo.CarpetaNo();
    begin
        //EjecutarComandos(227,'encenderNo')
    end;

procedure Tequipo.video();
    var
        orden_videovlc:string;
    begin
        //Bloquear();
        orden_videovlc:='videoVLC ' + g_ipvlc + ' ' + g_servidor;
        EjecutarComandosRoot(fIP,311,orden_videovlc);
    end;
procedure Tequipo.cierraUsuario();
var
ord_cierra_usuario:string;
begin
    if Trim(fUsuarioActivo) ='' then exit;;
    ord_cierra_usuario:='cierraUsuario ' + fUsuarioActivo;
    EjecutarComandosRoot('localhost',309,ord_cierra_usuario)
end;
procedure Tequipo.videoNo();
    begin
       // BloquearNo();
        EjecutarComandosRoot(fIP,312,'videoVLCNo')
    end;

procedure Tequipo.presentar();
    var
        orden_inicia_presentador:string;
    begin
        orden_inicia_presentador:='presentador ' + equipoProfesor.ContraVNCAlumno+' ' +equipoProfesor.host ;
        EjecutarPresentador(equipoProfesor.ArcContraVNC,orden_inicia_presentador);
    end;

procedure Tequipo.Internet();
    var
        orden_interner_equipo, usuarioin,orden_internet:string;
    begin
        if fEstadoActividadEquipo <> eUsuario then exit;
        usuarioin:=Trim(fUsuarioActivo);
        orden_internet:= 'activarInternet '+ usuarioin;
        EjecutarComandosRoot('localhost',304,orden_internet);
        orden_interner_equipo:='activarAccesoInternet '+ usuarioin;
        EjecutarComandosRoot(fIP,315,orden_interner_equipo);
    end;

procedure Tequipo.InternetNo();
    var
        orden_interner_equipo_no,usuarioin,orden_internetno:string;
    begin
         if fEstadoActividadEquipo <> eUsuario then exit;
        usuarioin:=Trim(fUsuarioActivo);
        orden_internetno:= 'desactivarInternet '+ usuarioin;
        EjecutarComandosRoot('localhost',303,orden_internetno);
        orden_interner_equipo_no:='desactivarAccesoInternet '+usuarioin;
        EjecutarComandosRoot(fIP,316,orden_interner_equipo_no);
    end;
procedure Tequipo.raton();
    var
        orden_mostrar_raton:string;
    begin
        orden_mostrar_raton:='raton ' + equipoProfesor.ContraVNCProfe;
        EjecutarComandos(214,orden_mostrar_raton);
        FPoseoRaton:=true;
    end;

procedure Tequipo.ratonNo();
    var
        orden_ratonno:string;
    begin
        orden_ratonno:='ratonNo ' + equipoProfesor.ContraVNCProfe;
        EjecutarComandos(215,orden_ratonno);
        FPoseoRaton:=false;
    end;

procedure Tequipo.Bloquear;
    var
        orden_bloquear:string;
    begin
        if fEstadoActividadEquipo <> eUsuario then exit;
        orden_bloquear:='desactivarTR' ;
        EjecutarComandos(219,orden_bloquear);
    end;

procedure Tequipo.BloquearNo;
    var
        orden_bloquearNo:string;
    begin
        if fEstadoActividadEquipo <> eUsuario then exit;
        orden_bloquearNo:='desactivarTRNo' ;
        EjecutarComandos(220,orden_bloquearNo);
    end;


function Tequipo.ObtenerProcesos():string;
    var
       orden,texto:string;
    begin
      texto:='';
      orden:='ps aux|tr -s " "|grep %s|grep -v vahi|grep -v .deskl|grep -v gbr|grep -v servera|grep -v ssh|grep -v bash|grep -v bonob|grep -v daemo|grep -v gnome|grep -v city|grep -v confd|grep -v "n/s"|grep -v "r/l"|grep -v "n-m"| grep -v grep|cut -f2,11 -d" "';
      if fEstadoActividadEquipo <> eUsuario then exit;
      orden:=Format(orden,[fUsuarioActivo]);
      texto:=HallarDato(orden);
      Result:=texto;
    end;

end.
